/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
#define LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP 0
#define LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386 1
#define LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc 2
#define LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc 11
#define LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb 21
#define LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack 22

#define LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb_p "lcrzotest"

/*-------------------------------------------------------------*/
/* define method for array */
#if defined LCRZODEF_SYSTEMARCH_i386
 #if LCRZODEF_SYSTEMARCH_i386==1
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386
 #endif
#endif
#if defined LCRZODEF_SYSTEMARCH_sparc
 #if LCRZODEF_SYSTEMARCH_sparc==1
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc
 #endif
#endif
#if ! defined LCRZO_DEBUG_BACKTRACE_METHODa
 #if defined __GNUC__ || defined __GCC__
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc
 #else
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP
 #endif
#endif

/* define method for display */
#define LCRZO_DEBUG_BACKTRACE_METHODd LCRZO_DEBUG_BACKTRACE_METHODa
#if defined LCRZODEF_SYSTEM_Unix
 #undef LCRZO_DEBUG_BACKTRACE_METHODd
 #define LCRZO_DEBUG_BACKTRACE_METHODd LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb
#endif

/* quick defines for debug */
#if 0
 #undef LCRZO_DEBUG_BACKTRACE_METHODa
 #if 0
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc
  #define LCRZO_DEBUG_BACKTRACE_METHODa LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP
 #endif
#endif
#if 0
 #undef LCRZO_DEBUG_BACKTRACE_METHODd
 #if 0
  #define LCRZO_DEBUG_BACKTRACE_METHODd LCRZO_DEBUG_BACKTRACE_METHODa
  #define LCRZO_DEBUG_BACKTRACE_METHODd LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb
  #define LCRZO_DEBUG_BACKTRACE_METHODd LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack
 #endif
#endif


/*-------------------------------------------------------------*/
int lcrzo_debug_backtrace_get_arch_i386(lcrzo_int32 btmaxsize, 
					void **bt,
					lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_get_arch_sparc(lcrzo_int32 btmaxsize, 
					 void **bt,
					 lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_get_dbg_gdb(lcrzo_int32 btmaxsize, 
				      void **bt,
				      lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_get_dbg_pstack(lcrzo_int32 btmaxsize, 
					 void **bt,
					 lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_get_compil_gcc(lcrzo_int32 btmaxsize, 
					 void **bt,
					 lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_get_unsup(lcrzo_int32 btmaxsize, 
				    void **bt,
				    lcrzo_int32 *pbtsize);
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386 || LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_ARCH_i386 1
#endif
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc || LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_ARCH_sparc 1
#endif
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb || LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG_gdb 1
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG 1
#endif
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack || LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG_pstack 1
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG 1
#endif
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc || LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_COMPIL_gcc 1
#endif
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP || LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP
 #define LCRZO_DEBUG_BACKTRACE_PROVIDE_UNSUP 1
#endif


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_UNSUP
/* empty backtrace */
int lcrzo_debug_backtrace_get_unsup(lcrzo_int32 btmaxsize, 
				    void **bt,
				    lcrzo_int32 *pbtsize)
{ 
  if (pbtsize!=NULL) *pbtsize=0;
  return(LCRZO_ERR_OK);
  bt=bt;
  btmaxsize=btmaxsize;
}
#endif


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_COMPIL_gcc
/* backtrace using gcc extension */
int lcrzo_debug_backtrace_get_compil_gcc(lcrzo_int32 btmaxsize, 
					 void **bt,
					 lcrzo_int32 *pbtsize)
{ void *p;
  lcrzo_bool getmoread;
  lcrzo_int32 i, j;

  i=0;
  getmoread=LCRZO_TRUE;
  for ( i=0 ; i<btmaxsize && getmoread ; i++ )
  { for ( j=0 ; j<2 && getmoread ; j++ )
    {switch((int)i)
     { case  0 : 
         p=(j==0)?(__builtin_frame_address(0)):(__builtin_return_address(0));
         break;
       case  1 :
	 p=(j==0)?(__builtin_frame_address(1)):(__builtin_return_address(1));
	 break;
       case  2 :
	 p=(j==0)?(__builtin_frame_address(2)):(__builtin_return_address(2));
	 break;
       case  3 : 
	 p=(j==0)?(__builtin_frame_address(3)):(__builtin_return_address(3));
	 break;
       case  4 :
	 p=(j==0)?(__builtin_frame_address(4)):(__builtin_return_address(4));
	 break;
       case  5 :
	 p=(j==0)?(__builtin_frame_address(5)):(__builtin_return_address(5));
	 break;
       case  6 :
	 p=(j==0)?(__builtin_frame_address(6)):(__builtin_return_address(6));
	 break;
       case  7 :
	 p=(j==0)?(__builtin_frame_address(7)):(__builtin_return_address(7));
	 break;
       case  8 :
	 p=(j==0)?(__builtin_frame_address(8)):(__builtin_return_address(8));
	 break;
       case  9 :
	 p=(j==0)?(__builtin_frame_address(9)):(__builtin_return_address(9));
	 break;
       case 10 :
	 p=(j==0)?(__builtin_frame_address(10)):(__builtin_return_address(10));
	 break;
       case 11 :
	 p=(j==0)?(__builtin_frame_address(11)):(__builtin_return_address(11));
	 break;
       case 12 :
	 p=(j==0)?(__builtin_frame_address(12)):(__builtin_return_address(12));
	 break;
       case 13 :
	 p=(j==0)?(__builtin_frame_address(13)):(__builtin_return_address(13));
	 break;
       case 14 :
	 p=(j==0)?(__builtin_frame_address(14)):(__builtin_return_address(14));
	 break;
       case 15 :
	 p=(j==0)?(__builtin_frame_address(15)):(__builtin_return_address(15));
	 break;
       case 16 :
	 p=(j==0)?(__builtin_frame_address(16)):(__builtin_return_address(16));
	 break;
       case 17 :
	 p=(j==0)?(__builtin_frame_address(17)):(__builtin_return_address(17));
	 break;
       case 18 :
	 p=(j==0)?(__builtin_frame_address(18)):(__builtin_return_address(18));
	 break;
       case 19 :
	 p=(j==0)?(__builtin_frame_address(19)):(__builtin_return_address(19));
	 break;
       case 20 :
	 p=(j==0)?(__builtin_frame_address(20)):(__builtin_return_address(20));
	 break;
       case 21 :
	 p=(j==0)?(__builtin_frame_address(21)):(__builtin_return_address(21));
	 break;
       case 22 :
	 p=(j==0)?(__builtin_frame_address(22)):(__builtin_return_address(22));
	 break;
       case 23 :
	 p=(j==0)?(__builtin_frame_address(23)):(__builtin_return_address(23));
	 break;
       case 24 :
	 p=(j==0)?(__builtin_frame_address(24)):(__builtin_return_address(24));
	 break;
       case 25 :
	 p=(j==0)?(__builtin_frame_address(25)):(__builtin_return_address(25));
	 break;
       case 26 :
	 p=(j==0)?(__builtin_frame_address(26)):(__builtin_return_address(26));
	 break;
       case 27 :
	 p=(j==0)?(__builtin_frame_address(27)):(__builtin_return_address(27));
	 break;
       case 28 :
	 p=(j==0)?(__builtin_frame_address(28)):(__builtin_return_address(28));
	 break;
       case 29 :
	 p=(j==0)?(__builtin_frame_address(29)):(__builtin_return_address(29));
	 break;
       case 30 :
	 p=(j==0)?(__builtin_frame_address(30)):(__builtin_return_address(30));
	 break;
       default : p=NULL;
      }
      if ( p==NULL )
      { getmoread=LCRZO_FALSE;
      }
      else
      { if (j==1)
        { bt[i]=p;
        }
      }
    }
  }
  if (pbtsize!=NULL) *pbtsize=i;
  return(LCRZO_ERR_OK);
}
#endif


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_ARCH_i386
/* backtrace using i386 processor */
int lcrzo_debug_backtrace_get_arch_i386(lcrzo_int32 btmaxsize,
					void **bt,
					lcrzo_int32 *pbtsize)
{ void *ebpp, *espp, *storedframemin, *ra, *nextframe;
  void **storedframe;
  lcrzo_int32 i;

#if defined LCRZODEF_SYSTEM_Unix
  ebpp=NULL; /* just for compiler warning */
  espp=NULL; /* just for compiler warning */
  __asm__ ("mov %%ebp, %0" : "=r"(ebpp) : );
  __asm__ ("mov %%esp, %0" : "=r"(espp) : );
#elif defined LCRZODEF_SYSTEM_Windows
  __asm { mov ebpp, ebp }
  __asm { mov espp, esp }
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif

  /* to help in debugging the function */
#define lcrzo_debug_backtrace_get_msg(st, ptr) printf("Error in lcrzo_debug_backtrace_get : %s (%p)\n", st, ptr);
#define lcrzo_debug_backtrace_get_msg2(st, ptr1, ptr2) printf("Error in lcrzo_debug_backtrace_get : %s (%p and %p)\n", st, ptr1, ptr2);
  /* this defines detects bad pointers */
#define lcrzo_debug_backtrace_get_badptr(p) (p==NULL||((lcrzo_uintmax)p&0x3))
  /* check if esp is valid (esp is only needed to check ebp) */
  if (lcrzo_debug_backtrace_get_badptr(espp))
  { lcrzo_debug_backtrace_get_msg("badptr(espp)", espp); 
    if (pbtsize!=NULL) *pbtsize=0;
    return(LCRZO_ERR_OK);
  }
  /* check if ebp is valid */
  if (lcrzo_debug_backtrace_get_badptr(ebpp))
  { lcrzo_debug_backtrace_get_msg("badptr(ebpp)", ebpp); 
    if (pbtsize!=NULL) *pbtsize=0;
    return(LCRZO_ERR_OK);
  }
  if (ebpp<=espp)
  { lcrzo_debug_backtrace_get_msg2("ebpp<=espp", ebpp, espp); 
    if (pbtsize!=NULL) *pbtsize=0;
    return(LCRZO_ERR_OK);
  }
  /* retrieve stack info */
  storedframe=(void **)ebpp;
  storedframemin=storedframe;
  for ( i=0 ; i<btmaxsize ; i++ )
  { /* get the return address and next frame */
    ra=storedframe[1];
    nextframe=storedframe[0];
    /* check ra */
    if (ra==NULL)
    { /* this is the normal ending condition for programs created with gcc */
      break;
    }
    /* do not do lcrzo_debug_backtrace_get_badptr(ra) because ra does not
       have to be aligned */
    /* check nextframe */
    if (nextframe==NULL)
    { /* this is the normal ending condition for programs created with gcc */
      break;
    }
    if (lcrzo_debug_backtrace_get_badptr(nextframe))
    { lcrzo_debug_backtrace_get_msg("badptr(nextframe)", nextframe); 
      break;
    }
    if (nextframe<=storedframemin)
    { lcrzo_debug_backtrace_get_msg2("nextframe<=storedframemin", 
				     nextframe, storedframemin); 
      break;
    }
    if (((lcrzo_uintmax)nextframe-(lcrzo_uintmax)storedframemin)>0x00100000u)
    {
#if defined LCRZODEF_SYSTEM_Unix
      lcrzo_debug_backtrace_get_msg2("nextframe-storedframemin>0x00100000u",
				     nextframe, storedframemin); 
#elif defined LCRZODEF_SYSTEM_Windows
      /* this is the normal ending condition for programs created with
         Visual C++ */
#endif
      break;
    }
    /* set info, and skip the frame */
    bt[i]=ra;
    storedframemin=storedframe;
    storedframe=(void **)(nextframe);
  }
  if (pbtsize!=NULL) *pbtsize=i;

  return(LCRZO_ERR_OK);
}
#endif


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_ARCH_sparc
/* backtrace using Sparc processor */
int lcrzo_debug_backtrace_get_badptr(lcrzo_ptr ptr,
				     lcrzo_bool allowunaligned,
				     lcrzo_bool *pisvalid);
int lcrzo_debug_backtrace_get_badptr(lcrzo_ptr ptr,
				     lcrzo_bool allowunaligned,
				     lcrzo_bool *pisvalid)
{ lcrzo_bool isvalid;
#if defined LCRZODEF_SYSTEM_Solaris
  static lcrzo_uint32 pagemask=(lcrzo_uint32)-1;
  lcrzo_ptr ptr2;
  char c;
#endif

  if (ptr==NULL)
  { if (pisvalid!=NULL) *pisvalid=LCRZO_FALSE;
    return(LCRZO_ERR_OK);
  }
 
  if ( !allowunaligned && ((lcrzo_uintmax)ptr&0x3) )
  { if (pisvalid!=NULL) *pisvalid=LCRZO_FALSE;
    return(LCRZO_ERR_OK);
  }
 
#if defined LCRZODEF_SYSTEM_Solaris
  if (pagemask==(lcrzo_uint32)-1)
  { /* need to set pagemask */
    pagemask = ~ ( sysconf(_SC_PAGESIZE) - 1 );
  }
  ptr2=(lcrzo_ptr)((lcrzo_uintmax)ptr & pagemask);
  if ( mincore(ptr2, 1, &c)==-1 && errno==ENOMEM )
    isvalid=LCRZO_FALSE;
  else
    isvalid=LCRZO_TRUE;
#else
  isvalid=LCRZO_TRUE;
#endif

  if (pisvalid!=NULL) *pisvalid=isvalid;
  return(LCRZO_ERR_OK);
}
int lcrzo_debug_backtrace_get_arch_sparc(lcrzo_int32 btmaxsize,
					 void **bt,
					 lcrzo_int32 *pbtsize)
{ void *fpp, *spp, *storedframemin, *ra, *nextframe;
  void **storedframe;
  lcrzo_int32 i;
  lcrzo_bool isvalid;

  /* Flush registers (ST_FLUSH_WINDOWS in /usr/include/sys/trap.h).
     With Sparcv9, should we use "flushw" ? */
  __asm__("ta 3"); 

  fpp=NULL; /* just for compiler warning */
  __asm__("mov %%fp, %0" : "=r"(fpp) :);
  spp=NULL; /* just for compiler warning */
  __asm__("mov %%sp, %0" : "=r"(spp) :);

  /* to help in debugging the function */
#define lcrzo_debug_backtrace_get_msg(st, ptr) printf("Error in lcrzo_debug_backtrace_get : %s (%p)\n", st, ptr);
#define lcrzo_debug_backtrace_get_msg2(st, ptr1, ptr2) printf("Error in lcrzo_debug_backtrace_get : %s (%p and %p)\n", st, ptr1, ptr2);
  /* check if esp is valid (esp is only needed to check ebp) */
  lcrzo_er2(lcrzo_debug_backtrace_get_badptr(spp, LCRZO_FALSE, &isvalid));
  if (!isvalid)
  { lcrzo_debug_backtrace_get_msg("badptr(spp)", spp); 
    if (pbtsize!=NULL) *pbtsize=0;
    return(LCRZO_ERR_OK);
  }
  /* check if ebp is valid */
  lcrzo_er2(lcrzo_debug_backtrace_get_badptr(fpp, LCRZO_FALSE, &isvalid));
  if (!isvalid)
  { lcrzo_debug_backtrace_get_msg("badptr(fpp)", fpp); 
    if (pbtsize!=NULL) *pbtsize=0;
    return(LCRZO_ERR_OK);
  }
  if (fpp<=spp)
  { lcrzo_debug_backtrace_get_msg2("fpp<=spp", fpp, spp); 
    if (pbtsize!=NULL) *pbtsize=0;
    return(LCRZO_ERR_OK);
  }
  /* retrieve stack info */
  storedframe=(void **)fpp;
  storedframemin=storedframe;
  for ( i=0 ; i<btmaxsize ; i++ )
  { /* get the return address and next frame */
    ra=storedframe[15];
    nextframe=storedframe[14];
    /* check ra */
    if (ra==NULL)
    { /* this is the normal ending condition for programs created with gcc */
      break;
    }
    lcrzo_er2(lcrzo_debug_backtrace_get_badptr(ra, LCRZO_TRUE, &isvalid));
    if (!isvalid)
    { lcrzo_debug_backtrace_get_msg("badptr(ra)", nextframe); 
      break;
    }
    /* check nextframe */
    if (nextframe==NULL)
    { /* this is the normal ending condition for programs created with gcc */
      break;
    }
    lcrzo_er2(lcrzo_debug_backtrace_get_badptr(nextframe, LCRZO_FALSE,
					       &isvalid));
    if (!isvalid)
    { lcrzo_debug_backtrace_get_msg("badptr(nextframe)", nextframe); 
      break;
    }
    if (nextframe<=storedframemin)
    { lcrzo_debug_backtrace_get_msg2("nextframe<=storedframemin", 
				     nextframe, storedframemin); 
      break;
    }
  #if 0
    /* do we need this ? */
    if (((lcrzo_uintmax)nextframe-(lcrzo_uintmax)storedframemin)>0x00100000u)
    { lcrzo_debug_backtrace_get_msg2("nextframe-storedframemin>0x00100000u",
				     nextframe, storedframemin); 
      break;
    }
  #endif
    /* set info, and skip the frame */
    bt[i]=ra;
    storedframemin=storedframe;
    storedframe=(void **)(nextframe);
  }
  if (pbtsize!=NULL) *pbtsize=i;

  return(LCRZO_ERR_OK);
}
#endif


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG
int lcrzo_debug_backtrace_dbg2(lcrzo_conststring dbgcmd,
			       lcrzo_conststring begstr,
			       lcrzo_conststring endstr,
			       lcrzo_uint16 method,
			       LCRZOFILE *pf,
			       lcrzo_int32 btmaxsize, 
			       void **bt,
			       lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_dbg2(lcrzo_conststring dbgcmd,
			       lcrzo_conststring begstr,
			       lcrzo_conststring endstr,
			       lcrzo_uint16 method,
			       LCRZOFILE *pf,
			       lcrzo_int32 btmaxsize, 
			       void **bt,
			       lcrzo_int32 *pbtsize)
{ lcrzo_uint32 pid;
  lcrzo_int32 btsize;
  lcrzo_bool canprint;
  int fd, status, ret;
  char buf[512];

  lcrzo_er(lcrzo_debug_exec_init(dbgcmd, &pid, &fd));
  /* we have to stop the current process and to wait the end of the debugger.
     Otherwise, when the debugger attaches, it is too late */
  ret=waitpid(pid, &status, 0);
  if (ret==-1) return(LCRZO_ERR_FUWAITPID);
  if (WIFEXITED(status))
  { if (WEXITSTATUS(status)!=0) return(LCRZO_ERR_FUEXECL);
  }
  else
  { return(LCRZO_ERR_OKPROCESSABRUPTTERM);
  }

  /* read each line */
  canprint=LCRZO_FALSE;
  btsize=0;
  if (begstr==NULL) canprint=LCRZO_TRUE;
  while (LCRZO_TRUE)
  { ret=lcrzo_debug_exec_readline(fd, sizeof(buf), buf);
    if (ret!=LCRZO_ERR_OK) break;
    if ( !canprint && !strcmp(buf, begstr) )
    { canprint=LCRZO_TRUE;
    }
    else if ( canprint && endstr!=NULL && !strcmp(buf, endstr) )
    { canprint=LCRZO_FALSE;
    }
    else if ( canprint )
    { if (method==1)
      { fprintf((FILE*)pf, "%s\n", buf);
      }
      else if (method==2)
      { int n;
        lcrzo_uintmax ad;
	ret=sscanf(buf, "#%d 0x%lx ", &n, &ad);
        if (ret==2)
	{ if (btsize<btmaxsize)
	  { bt[btsize]=(lcrzo_ptr)ad;
  	    btsize++;
	  }
	}
      }
      else if (method==3)
      { lcrzo_uintmax ad;
        if (buf[0]==' ')
	{ ret=sscanf(buf, " %lx ", &ad);
          if (ret==1)
	  { if (btsize<btmaxsize)
	    { bt[btsize]=(lcrzo_ptr)ad;
  	      btsize++;
	    }
	  }
	}
      }
      else
	return(LCRZO_ERR_IEINTERNALERROR);
    }
  }
  if (ret==LCRZO_ERR_OKDATAEND) ret=LCRZO_ERR_OK;
  lcrzo_er(lcrzo_debug_exec_close(pid, fd));
  if (pbtsize!=NULL) *pbtsize=btsize;
  return(ret);
}
#endif

/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG_gdb
int lcrzo_debug_backtrace_dbg_gdb(lcrzo_bool fillarray,
				  LCRZOFILE *pf,
				  lcrzo_int32 btmaxsize, 
				  void **bt,
				  lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_dbg_gdb(lcrzo_bool fillarray,
				  LCRZOFILE *pf,
				  lcrzo_int32 btmaxsize, 
				  void **bt,
				  lcrzo_int32 *pbtsize)
{ char dbgcmd[512];
  static int displayed=LCRZO_FALSE;

  if (!displayed)
  { printf("Backtrace on %s\n", LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb_p);
    displayed=LCRZO_TRUE;
  }

#if defined LCRZODEF_SYSTEM_Linux || defined LCRZODEF_SYSTEM_Solaris
  lcrzo_er(lcrzo_debug_str_init(dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("gdb -q ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb_p,
				       sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_int((int)getpid(), "%d", 
				      sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" 2>/dev/null", sizeof(dbgcmd),dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" <<EOF\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("set prompt -+-+-+\n",
				       sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("bt\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("detach\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("quit\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("EOF\n", sizeof(dbgcmd), dbgcmd));
  if (fillarray)
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					"-+-+-+bt", "-+-+-+detach", 2,
					pf, btmaxsize, bt, pbtsize));
  }
  else
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					"-+-+-+bt", "-+-+-+detach", 1,
					pf, btmaxsize, bt, pbtsize));
  }
#elif defined LCRZODEF_SYSTEM_FreeBSD
  lcrzo_er(lcrzo_debug_str_init(dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("gdb -q ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb_p,
				       sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_int((int)getpid(), "%d", 
				      sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" 2>/dev/null", sizeof(dbgcmd),dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" <<EOF\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("bt\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("detach\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("shell kill -SIGCONT ", 
				       sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_int((int)getpid(), "%d", 
				      sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("quit\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("EOF\n", sizeof(dbgcmd), dbgcmd));
  if (fillarray)
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					NULL, NULL, 2,
					pf, btmaxsize, bt, pbtsize));
  }
  else
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					NULL, NULL, 1,
					pf, btmaxsize, bt, pbtsize));
  }
#elif defined LCRZODEF_SYSTEM_OpenBSD
  lcrzo_er(lcrzo_debug_str_init(dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("gdb -q ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb_p,
				       sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_int((int)getpid(), "%d", 
				      sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" 2>/dev/null", sizeof(dbgcmd),dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text(" <<EOF\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("bt\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("detach\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("quit\n", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("EOF\n", sizeof(dbgcmd), dbgcmd));
  if (fillarray)
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					NULL, NULL, 2,
					pf, btmaxsize, bt, pbtsize));
  }
  else
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					NULL, NULL, 1,
					pf, btmaxsize, bt, pbtsize));
  }
#endif
  return(LCRZO_ERR_OK);
}
#endif

/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG_pstack
int lcrzo_debug_backtrace_dbg_pstack(lcrzo_bool fillarray,
				     LCRZOFILE *pf,
				     lcrzo_int32 btmaxsize, 
				     void **bt,
				     lcrzo_int32 *pbtsize);
int lcrzo_debug_backtrace_dbg_pstack(lcrzo_bool fillarray,
				     LCRZOFILE *pf,
				     lcrzo_int32 btmaxsize, 
				     void **bt,
				     lcrzo_int32 *pbtsize)
{ char dbgcmd[512];
  static int displayed=LCRZO_FALSE;

  if (!displayed)
  { printf("Backtrace on %s\n", LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb_p);
    displayed=LCRZO_TRUE;
  }

  lcrzo_er(lcrzo_debug_str_init(dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("pstack ", sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_int((int)getpid(), "%d", 
				      sizeof(dbgcmd), dbgcmd));
  lcrzo_er(lcrzo_debug_str_append_text("\n", sizeof(dbgcmd), dbgcmd));
  if (fillarray)
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					NULL, NULL, 3,
					pf, btmaxsize, bt, pbtsize));
  }
  else
  { lcrzo_er(lcrzo_debug_backtrace_dbg2(dbgcmd, 
					NULL, NULL, 1,
					pf, btmaxsize, bt, pbtsize));
  }

  return(LCRZO_ERR_OK);
}
#endif

/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG_gdb
int lcrzo_debug_backtrace_get_dbg_gdb(lcrzo_int32 btmaxsize, 
				      void **bt,
				      lcrzo_int32 *pbtsize)
{ return(lcrzo_debug_backtrace_dbg_gdb(LCRZO_TRUE, NULL,
				       btmaxsize, bt, pbtsize));
}
#endif

/*-------------------------------------------------------------*/
#if defined LCRZO_DEBUG_BACKTRACE_PROVIDE_DBG_pstack
int lcrzo_debug_backtrace_get_dbg_pstack(lcrzo_int32 btmaxsize, 
					 void **bt,
					 lcrzo_int32 *pbtsize)
{ return(lcrzo_debug_backtrace_dbg_pstack(LCRZO_TRUE, NULL,
					  btmaxsize, bt, pbtsize));
}
#endif

/*-------------------------------------------------------------*/
int lcrzo_debug_backtrace_get(lcrzo_int32 btmaxsize, 
			      void **bt,
			      lcrzo_int32 *pbtsize)
{ 
#if LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386
  return(lcrzo_debug_backtrace_get_arch_i386(btmaxsize, bt, pbtsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc
  return(lcrzo_debug_backtrace_get_arch_sparc(btmaxsize, bt, pbtsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb
  return(lcrzo_debug_backtrace_get_dbg_gdb(btmaxsize, bt, pbtsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack
  return(lcrzo_debug_backtrace_get_dbg_pstack(btmaxsize, bt, pbtsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc
  return(lcrzo_debug_backtrace_get_compil_gcc(btmaxsize, bt, pbtsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODa==LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP
  return(lcrzo_debug_backtrace_get_unsup(btmaxsize, bt, pbtsize));
#endif
}

/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
int lcrzo_debug_backtrace_fprint(LCRZOFILE *pf)
#if LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_gdb
{ return(lcrzo_debug_backtrace_dbg_gdb(LCRZO_FALSE, pf, 0, NULL, NULL));
}
#elif LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_DBG_pstack
{ return(lcrzo_debug_backtrace_dbg_pstack(LCRZO_FALSE, pf, 0, NULL, NULL));
}
#else
{ void * bt[LCRZO_DEBUG_BACKTRACE_MAXSIZE];
  lcrzo_int32 btsize, i;

  /* first, get the back trace */
#if LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_i386
  lcrzo_er(lcrzo_debug_backtrace_get_arch_i386(LCRZO_DEBUG_BACKTRACE_MAXSIZE,
					       bt, &btsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_ARCH_sparc
  lcrzo_er(lcrzo_debug_backtrace_get_arch_sparc(LCRZO_DEBUG_BACKTRACE_MAXSIZE,
						bt, &btsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_COMPIL_gcc
  lcrzo_er(lcrzo_debug_backtrace_get_compil_gcc(LCRZO_DEBUG_BACKTRACE_MAXSIZE,
						bt, &btsize));
#elif LCRZO_DEBUG_BACKTRACE_METHODd==LCRZO_DEBUG_BACKTRACE_METHOD_UNSUP
  lcrzo_er(lcrzo_debug_backtrace_get_unsup(LCRZO_DEBUG_BACKTRACE_MAXSIZE,
					   bt, &btsize));
#endif
  if (btsize==0)
  { printf("Backtrace is empty (unsupported ?).\n");
  }
  else
  { /* we should use "%p", but one some systems, it prints "0x12" (Linux),
       and on others "12" (Solaris) */
    for ( i=0 ; i<btsize-1 ; i++ )
    { fprintf((FILE*)pf, "0x%lX,", (lcrzo_uintmax)bt[i]);
    }
    fprintf((FILE*)pf, "0x%lX\n", (lcrzo_uintmax)bt[btsize-1]);
  }
  return(LCRZO_ERR_OK);
}
#endif


