/* This file is part of Lcrzo.
*/

#ifdef LCRZODEF_SYSTEM_Unix
  /* this function is not needed*/

#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_RES_FDOPEN==1
/* This critical section is for not doing two checks simultaneously */
CRITICAL_SECTION lcrzo_debug_cs_resfdopen;
#endif


/*-------------------------------------------------------------*/
int lcrzo_debug_cs_init(void)
{
#if LCRZO_DEBUG_RES_FDOPEN==1
  InitializeCriticalSection(&lcrzo_debug_cs_resfdopen);
#endif
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_debug_cs_close(void)
{
#if LCRZO_DEBUG_RES_FDOPEN==1
  DeleteCriticalSection(&lcrzo_debug_cs_resfdopen);
#endif
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_RES_FDOPEN==1
int lcrzo_debug_cs_resfdopen_enter(void)
{ EnterCriticalSection(&lcrzo_debug_cs_resfdopen);
  return(LCRZO_ERR_OK);
}
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_RES_FDOPEN==1
int lcrzo_debug_cs_resfdopen_leave(void)
{ LeaveCriticalSection(&lcrzo_debug_cs_resfdopen);
  return(LCRZO_ERR_OK);
}
#endif


#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
