/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
int lcrzo_debug_str_init(lcrzo_string stringout)
{ 
  if (stringout==NULL) return(LCRZO_ERR_PANULLPTR);
  stringout[0]='\0';
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_debug_str_append_text(lcrzo_conststring text,
				lcrzo_int32 stringoutmaxsize,
				lcrzo_string stringout)
{ lcrzo_int32 strlenstringout, strlentext;

  if (text==NULL) return(LCRZO_ERR_PANULLPTR);
  if (stringoutmaxsize<0) return(LCRZO_ERR_PATOOLOW);
  if (stringout==NULL) return(LCRZO_ERR_PANULLPTR);

  strlenstringout=strlen(stringout);
  strlentext=strlen(text);

  if ( strlenstringout > stringoutmaxsize-1 )
    return(LCRZO_ERR_PADATACURSUPMAX);

  if ( strlenstringout+strlentext > stringoutmaxsize-1 )
    return(LCRZO_ERR_OKDATATRUNCATED);

  strcat(stringout, text);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_debug_str_append_int(lcrzo_int32 integer,
			       lcrzo_conststring format,
			       lcrzo_int32 stringoutmaxsize,
			       lcrzo_string stringout)
{ char tmp[101];

  /*parameters verification*/
  if (format==NULL) return(LCRZO_ERR_PANULLPTR);
  if (stringoutmaxsize<0) return(LCRZO_ERR_PATOOLOW);
  if (stringout==NULL) return(LCRZO_ERR_PANULLPTR);

  /*copy the integer*/
  sprintf(tmp, format, integer);
  lcrzo_er(lcrzo_debug_str_append_text(tmp, stringoutmaxsize, stringout));
  return(LCRZO_ERR_OK);
}

