/* This file is part of Lcrzo.
*/

#ifdef LCRZODEF_SYSTEM_Unix
  /* this function is not needed*/

#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl_NTregistry(lcrzo_ipl iplwanted, 
                                           lcrzo_device device);
int lcrzo_priv_conf_device_init_ipl_NTregistry(lcrzo_ipl iplwanted, 
                                           lcrzo_device device)
{
  return(lcrzo_priv_conf_init_NTregistry(LCRZO_FALSE, LCRZO_FALSE,
                                          LCRZO_TRUE, iplwanted, device));
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl_2kregistry(lcrzo_ipl iplwanted, 
                                           lcrzo_device device);
int lcrzo_priv_conf_device_init_ipl_2kregistry(lcrzo_ipl iplwanted, 
                                           lcrzo_device device)
{
  return(lcrzo_priv_conf_init_2kregistry(LCRZO_FALSE, LCRZO_FALSE,
                                          LCRZO_TRUE, iplwanted, device));
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl_W9xregistry(lcrzo_ipl iplwanted,
                                                 lcrzo_device device);
int lcrzo_priv_conf_device_init_ipl_W9xregistry(lcrzo_ipl iplwanted,
                                                 lcrzo_device device)
{
  return(lcrzo_priv_conf_init_W9xregistry(LCRZO_FALSE, LCRZO_FALSE,
                                          LCRZO_TRUE, iplwanted, device));
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl_packetdll(lcrzo_ipl iplwanted, 
				              lcrzo_device device);
int lcrzo_priv_conf_device_init_ipl_packetdll(lcrzo_ipl iplwanted, 
				              lcrzo_device device)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_deviceeth de;
  lcrzo_int32 i, count;
  lcrzo_device dev;
  lcrzo_ipl ip, mask;
  BOOL err;
  int ret;
  
  /* packet dll does not work in this case */
  if (iplwanted==0) return(LCRZO_ERR_OKUNRESOLVED);

  lcrzo_er(lcrzo_priv_conf_localdevice_eventuallyinit());
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  ret=lcrzo_list_count(&ptrcv->list_localdevice, &count);

  /* loop for each adapter name */
  if (ret==LCRZO_ERR_OK)
  {
    for ( i=1 ; i<=count ; i++ )
    { ret=lcrzo_list_value_pos(&ptrcv->list_localdevice, i, &de);
      if (ret==LCRZO_ERR_OK)
      { /* get the IP address for this device */
        ret=lcrzo_priv_ascii_init_device(de.device, dev);
        if (ret==LCRZO_ERR_OK)
        { err=PacketGetNetInfo(dev, &ip, &mask);
          if (err)
          { /* unfortunately does not work on RAS */
            /*lcrzo_er(lcrzo_ipl_print("packetip=", ip, "\n"));*/
            if ( ip == iplwanted )
            { lcrzo_er(lcrzo_device_init(de.device, device));
              return(LCRZO_ERR_OK);
            }
          }
        }
      }
    }
  }
  return(LCRZO_ERR_OKUNRESOLVED);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl_winras(lcrzo_ipl iplwanted, 
				           lcrzo_device device);
int lcrzo_priv_conf_device_init_ipl_winras(lcrzo_ipl iplwanted, 
				           lcrzo_device device)
{ lcrzo_priv_globalvars *ptrglo;
  lcrzo_bool yes;
  int ret;
  
  lcrzo_er(lcrzo_priv_conf_winras_isarasip(iplwanted, &yes));

  if (!yes) return(LCRZO_ERR_OKUNRESOLVED);

  lcrzo_er(lcrzo_priv_globalvars_ptr_get(&ptrglo));
  ret=LCRZO_ERR_OKUNRESOLVED;
  switch((int)ptrglo->windows_systemversion)
  { case LCRZO_WINDOWS_SYSTEMVERSION_2k:
      lcrzo_er(lcrzo_device_init("\\Device\\Packet_NdisWanIp", device));
	  ret=LCRZO_ERR_OK;
      break;

    case LCRZO_WINDOWS_SYSTEMVERSION_95:
    case LCRZO_WINDOWS_SYSTEMVERSION_98:
	  lcrzo_er(lcrzo_device_init("PPPMAC", device));
	  ret=LCRZO_ERR_OK;
      break;
  }
  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl(lcrzo_ipl iplwanted, 
        			    lcrzo_device device);
int lcrzo_priv_conf_device_init_ipl(lcrzo_ipl iplwanted, 
				    lcrzo_device device)
{ lcrzo_bool bugged;
  lcrzo_priv_globalvars *ptrglo;
  int ret;
  
  if ( iplwanted==0 ) return(LCRZO_ERR_OKUNRESOLVED);

  /* special loopback case */
  if ( iplwanted==0x7F000001 )
  { lcrzo_er(lcrzo_device_init("Loopback", device));
    return(LCRZO_ERR_OK);
  }

  lcrzo_er(lcrzo_priv_globalvars_ptr_get(&ptrglo));
  switch((int)ptrglo->windows_systemversion)
  { case LCRZO_WINDOWS_SYSTEMVERSION_nt4:
      ret=lcrzo_priv_conf_device_init_ipl_NTregistry(iplwanted, device);
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_packetdll(iplwanted, device);
      }
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_winras(iplwanted, device);
      }
      break;

    case LCRZO_WINDOWS_SYSTEMVERSION_2k:
    case LCRZO_WINDOWS_SYSTEMVERSION_xp:
      ret=lcrzo_priv_conf_device_init_ipl_2kregistry(iplwanted, device);
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_packetdll(iplwanted, device);
      }
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_winras(iplwanted, device);
      }
      break;

    case LCRZO_WINDOWS_SYSTEMVERSION_95:
      ret=lcrzo_priv_conf_device_init_ipl_W9xregistry(iplwanted, device);
      if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_winras(iplwanted, device);
      }
      if ( ret!=LCRZO_ERR_OK )
      { lcrzo_er(lcrzo_priv_conf_winras_w95bugged(&bugged));
        if ( !bugged )
        { ret=lcrzo_priv_conf_device_init_ipl_packetdll(iplwanted, device);
	}
      }
      break;

    case LCRZO_WINDOWS_SYSTEMVERSION_98:
    case LCRZO_WINDOWS_SYSTEMVERSION_me:
      ret=lcrzo_priv_conf_device_init_ipl_W9xregistry(iplwanted, device);
      if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_packetdll(iplwanted, device);
      }
      if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_winras(iplwanted, device);
      }
      break;

    default:
      ret=lcrzo_priv_conf_device_init_ipl_2kregistry(iplwanted, device);
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_NTregistry(iplwanted, device);
      }
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_W9xregistry(iplwanted, device);
      }
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_packetdll(iplwanted, device);
      }
	  if ( ret!=LCRZO_ERR_OK )
      { ret=lcrzo_priv_conf_device_init_ipl_winras(iplwanted, device);
      }
      break;
  }

  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_device_init_ipl_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_device_init_ipl_debug_fprint(LCRZOFILE *pf)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_devices cd;
  lcrzo_int32 count, i, j;
  lcrzo_device device;
  int ret;

  fprintf(pf, "\n\nFor each ipl in this table, obtain the device with \nlcrzo_priv_conf_device_init_ipl\n");
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, i, &cd));
    ret=lcrzo_priv_conf_device_init_ipl(cd.ip, device);
    lcrzo_er(lcrzo_ipl_fprint(pf, "ip=", cd.ip, "\t"));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_device_fprint(pf, "device=", device, "\n"));
    }
    else
    { lcrzo_er(lcrzo_err_fprint(pf, ret));
    }
	if ( ret==LCRZO_ERR_OK && !strlen(device) )
	{ for (j=0;j<10;j++) puts("INTERNAL ERROR");
	}
  }

  fprintf(pf, "\n\nFor each ipl in this table, obtain the device with \nlcrzo_priv_conf_device_init_ipl_NTregistry\n");
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, i, &cd));
    ret=lcrzo_priv_conf_device_init_ipl_NTregistry(cd.ip, device);
    lcrzo_er(lcrzo_ipl_fprint(pf, "ip=", cd.ip, "\t"));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_device_fprint(pf, "device=", device, "\n"));
    }
    else
    { lcrzo_er(lcrzo_err_fprint(pf, ret));
    }
	if ( ret==LCRZO_ERR_OK && !strlen(device) )
	{ for (j=0;j<10;j++) puts("INTERNAL ERROR");
	}
  }

  fprintf(pf, "\n\nFor each ipl in this table, obtain the device with \nlcrzo_priv_conf_device_init_ipl_2kregistry\n");
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, i, &cd));
    ret=lcrzo_priv_conf_device_init_ipl_2kregistry(cd.ip, device);
    lcrzo_er(lcrzo_ipl_fprint(pf, "ip=", cd.ip, "\t"));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_device_fprint(pf, "device=", device, "\n"));
    }
    else
    { lcrzo_er(lcrzo_err_fprint(pf, ret));
    }
	if ( ret==LCRZO_ERR_OK && !strlen(device) )
	{ for (j=0;j<10;j++) puts("INTERNAL ERROR");
	}
  }

  fprintf(pf, "\n\nFor each ipl in this table, obtain the device with \nlcrzo_priv_conf_device_init_ipl_W9xregistry\n");
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, i, &cd));
    ret=lcrzo_priv_conf_device_init_ipl_W9xregistry(cd.ip, device);
    lcrzo_er(lcrzo_ipl_fprint(pf, "ip=", cd.ip, "\t"));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_device_fprint(pf, "device=", device, "\n"));
    }
    else
    { lcrzo_er(lcrzo_err_fprint(pf, ret));
    }
	if ( ret==LCRZO_ERR_OK && !strlen(device) )
	{ for (j=0;j<10;j++) puts("INTERNAL ERROR");
	}
  }

  fprintf(pf, "\n\nFor each ipl in this table, obtain the device with \nlcrzo_priv_conf_device_init_ipl_packetdll\n");
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, i, &cd));
    ret=lcrzo_priv_conf_device_init_ipl_packetdll(cd.ip, device);
    lcrzo_er(lcrzo_ipl_fprint(pf, "ip=", cd.ip, "\t"));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_device_fprint(pf, "device=", device, "\n"));
    }
    else
    { lcrzo_er(lcrzo_err_fprint(pf, ret));
    }
	if ( ret==LCRZO_ERR_OK && !strlen(device) )
	{ for (j=0;j<10;j++) puts("INTERNAL ERROR");
	}
  }

  fprintf(pf, "\n\nFor each ipl in this table, obtain the device with \nlcrzo_priv_conf_device_init_ipl_winras\n");
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, i, &cd));
    ret=lcrzo_priv_conf_device_init_ipl_winras(cd.ip, device);
    lcrzo_er(lcrzo_ipl_fprint(pf, "ip=", cd.ip, "\t"));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_device_fprint(pf, "device=", device, "\n"));
    }
    else
    { lcrzo_er(lcrzo_err_fprint(pf, ret));
    }
	if ( ret==LCRZO_ERR_OK && !strlen(device) )
	{ for (j=0;j<10;j++) puts("INTERNAL ERROR");
	}
  }

  return(LCRZO_ERR_OK);
}


#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
