/* This file is part of Lcrzo.
*/

/* This file is part of Lcrzo.
*/

#ifdef LCRZODEF_SYSTEM_Unix
  /* this function is not needed*/

#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_incomplete_debug_fprint(LCRZOFILE *pf)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci;
  lcrzo_int32 i, count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));

    if (lpci.devicenumberset)
    { lcrzo_er(lcrzo_uint32_fprint(pf, " devnum=", lpci.devicenumber,
				   "%u", ""));
    }
    if (lpci.deviceset)
    { lcrzo_er(lcrzo_device_fprint(pf, " device=", lpci.device, ""));
    }
    if (lpci.hwtypeset)
    { lcrzo_er(lcrzo_int16_fprint(pf, " hwtype=", lpci.hwtype, "%d", ""));
    }
    if (lpci.ethset)
    { lcrzo_er(lcrzo_etha_fprint(pf, " eth=", lpci.eth, ""));
    }
    if (lpci.ipset)
    { lcrzo_er(lcrzo_ipl_fprint(pf, " ip=", lpci.ip, ""));
    }
    if (lpci.netmaskset)
    { lcrzo_er(lcrzo_ipl_fprint(pf, " netmask=", lpci.netmask, ""));
    }
    if (lpci.mtuset)
    { lcrzo_er(lcrzo_uint32_fprint(pf, " mtu=", lpci.mtu, "%u", ""));
    }
    if (lpci.isupset)
    { lcrzo_er(lcrzo_bool_fprint(pf, " isup=", lpci.isup, ""));
    }
    if (lpci.isanaliasset)
    { lcrzo_er(lcrzo_bool_fprint(pf, " isanalias=", lpci.isanalias, ""));
    }
    if (lpci.ispointtopointset)
    { lcrzo_er(lcrzo_bool_fprint(pf, " isptp=", lpci.ispointtopoint, ""));
    }
    if (lpci.pointtopointiplset)
    { lcrzo_er(lcrzo_ipl_fprint(pf, " ptpipl=", lpci.pointtopointipl, ""));
    }

    fprintf(pf, "%s", "\n");
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add(lcrzo_bool devicenumberset,
                                   lcrzo_uint32 devicenumber,
                                   lcrzo_bool deviceset,
                                   lcrzo_constdevice device,
                                   lcrzo_bool hwtypeset,
                                   lcrzo_int16 hwtype,
                                   lcrzo_bool ethset,
                                   lcrzo_constetha eth,
                                   lcrzo_bool ipset,
                                   lcrzo_ipl ip,
                                   lcrzo_bool netmaskset,
                                   lcrzo_ipl netmask,
                                   lcrzo_bool mtuset,
                                   lcrzo_uint32 mtu,
                                   lcrzo_bool isupset,
                                   lcrzo_bool isup,
                                   lcrzo_bool isanaliasset,
                                   lcrzo_bool isanalias,
                                   lcrzo_bool ispointtopointset,
                                   lcrzo_bool ispointtopoint,
                                   lcrzo_bool pointtopointiplset,
                                   lcrzo_ipl pointtopointipl);
int lcrzo_priv_conf_incomplete_add(lcrzo_bool devicenumberset,
                                   lcrzo_uint32 devicenumber,
                                   lcrzo_bool deviceset,
                                   lcrzo_constdevice device,
                                   lcrzo_bool hwtypeset,
                                   lcrzo_int16 hwtype,
                                   lcrzo_bool ethset,
                                   lcrzo_constetha eth,
                                   lcrzo_bool ipset,
                                   lcrzo_ipl ip,
                                   lcrzo_bool netmaskset,
                                   lcrzo_ipl netmask,
                                   lcrzo_bool mtuset,
                                   lcrzo_uint32 mtu,
                                   lcrzo_bool isupset,
                                   lcrzo_bool isup,
                                   lcrzo_bool isanaliasset,
                                   lcrzo_bool isanalias,
                                   lcrzo_bool ispointtopointset,
                                   lcrzo_bool ispointtopoint,
                                   lcrzo_bool pointtopointiplset,
                                   lcrzo_ipl pointtopointipl)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci;

  lpci.devicenumberset=devicenumberset;
  if (devicenumberset)
  { lpci.devicenumber=devicenumber;
  }

  lpci.deviceset=deviceset;
  if (deviceset)
  { lcrzo_er(lcrzo_device_init(device, lpci.device));
  }

  if ( hwtypeset && hwtype==LCRZO_DEVICE_HWTYPE_UNKNOWN )
  { hwtypeset=LCRZO_FALSE;
    ethset=LCRZO_FALSE;
  }
  lpci.hwtypeset=hwtypeset;
  if (hwtypeset)
  { lpci.hwtype=hwtype;
  }

  lpci.ethset=ethset;
  if (ethset)
  { lcrzo_er(lcrzo_etha_init_etha(eth, lpci.eth));
  }

  if ( ipset && ip==0 ) ipset=LCRZO_FALSE;
  lpci.ipset=ipset;
  if (ipset)
  { lpci.ip=ip;
  }

  if ( netmaskset && netmask==0 ) netmaskset=LCRZO_FALSE;
  lpci.netmaskset=netmaskset;
  if (netmaskset)
  { lpci.netmask=netmask;
  }

  lpci.mtuset=mtuset;
  if (mtuset)
  { lpci.mtu=mtu;
  }

  lpci.isupset=isupset;
  if (isupset)
  { lpci.isup=isup;
  }

  lpci.isanaliasset=isanaliasset;
  if (isanaliasset)
  { lpci.isanalias=isanalias;
  }

  if ( !ispointtopointset ) pointtopointiplset=LCRZO_FALSE;
  if ( ispointtopointset && pointtopointiplset && pointtopointipl==0 )
  { ispointtopointset=LCRZO_FALSE;
    pointtopointiplset=LCRZO_FALSE;
  }
  lpci.ispointtopointset=ispointtopointset;
  if (ispointtopointset)
  { lpci.ispointtopoint=ispointtopoint;
  }

  lpci.pointtopointiplset=pointtopointiplset;
  if (pointtopointiplset)
  { lpci.pointtopointipl=pointtopointipl;
  }

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_add_last(&ptrcv->list_incomplete, &lpci));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_1(lcrzo_uint32 devicenumber,
                                     lcrzo_int16 hwtype,
                                     lcrzo_constetha eth,
                                     lcrzo_ipl ip,
                                     lcrzo_ipl netmask,
                                     lcrzo_uint32 mtu);
int lcrzo_priv_conf_incomplete_add_1(lcrzo_uint32 devicenumber,
                                     lcrzo_int16 hwtype,
                                     lcrzo_constetha eth,
                                     lcrzo_ipl ip,
                                     lcrzo_ipl netmask,
                                     lcrzo_uint32 mtu)
{
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_TRUE, devicenumber, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, hwtype, 
                                          LCRZO_TRUE, eth, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_TRUE, netmask, 
                                          LCRZO_TRUE, mtu, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_2(lcrzo_constdevice device,
                                     lcrzo_ipl ip);
int lcrzo_priv_conf_incomplete_add_2(lcrzo_constdevice device,
                                     lcrzo_ipl ip)
{
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, device, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_3(lcrzo_uint32 devicenumber,
                                     lcrzo_int16 hwtype,
                                     lcrzo_constetha eth,
                                     lcrzo_ipl ip);
int lcrzo_priv_conf_incomplete_add_3(lcrzo_uint32 devicenumber,
                                     lcrzo_int16 hwtype,
                                     lcrzo_constetha eth,
                                     lcrzo_ipl ip)
{
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_TRUE, devicenumber, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, hwtype, 
                                          LCRZO_TRUE, eth, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_4(lcrzo_uint32 devicenumber,
                                     lcrzo_ipl ip);
int lcrzo_priv_conf_incomplete_add_4(lcrzo_uint32 devicenumber,
                                     lcrzo_ipl ip)
{
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_TRUE, devicenumber, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_5(lcrzo_constdevice device,
                                     lcrzo_ipl ip,
                                     lcrzo_ipl mask,
                                     lcrzo_bool isanalias);
int lcrzo_priv_conf_incomplete_add_5(lcrzo_constdevice device,
                                     lcrzo_ipl ip,
                                     lcrzo_ipl mask,
                                     lcrzo_bool isanalias)
{
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, device, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_TRUE, mask, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_TRUE, isanalias,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_6(lcrzo_uint32 devicenumber,
                                     lcrzo_ipl ip,
                                     lcrzo_ipl mask,
                                     lcrzo_bool isanalias);
int lcrzo_priv_conf_incomplete_add_6(lcrzo_uint32 devicenumber,
                                     lcrzo_ipl ip,
                                     lcrzo_ipl mask,
                                     lcrzo_bool isanalias)
{
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_TRUE, devicenumber, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_TRUE, mask, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_TRUE, isanalias,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_add_7(lcrzo_constdevice device);
int lcrzo_priv_conf_incomplete_add_7(lcrzo_constdevice device)
{ lcrzo_etha etha;

  lcrzo_er(lcrzo_etha_initdefault(etha));
  lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, device, 
                                          LCRZO_TRUE, LCRZO_DEVICE_HWTYPE_PPP, 
                                          LCRZO_TRUE, etha, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_FALSE, 0));

  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_complete_dev(void);
int lcrzo_priv_conf_incomplete_complete_dev(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_devices cd;
  lcrzo_priv_conf_deviceeth de;
  lcrzo_int32 pi, pcount, ci, ccount;
  lcrzo_etha etha;
  lcrzo_int16 hwtype;
  lcrzo_bool found, deviceequal;
  int ret;

  lcrzo_er(lcrzo_priv_conf_localdevice_eventuallyinit());
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_localdevice, &pcount));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &ccount));
  for ( pi=1 ; pi<=pcount ; pi++ )
  { found=LCRZO_FALSE;
    lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_localdevice, pi, &de));
    for ( ci=1 ; ci<=ccount ; ci++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, ci, &cd));
      lcrzo_er(lcrzo_device_equal2(cd.device, de.device, &deviceequal));
      if ( deviceequal )
      { found=LCRZO_TRUE;
        break;
      }
    }
    if (!found)
    { ret=lcrzo_priv_conf_etha_init_cardnumberdevice(de.device, 2000,2000,LCRZO_FALSE, &hwtype, etha);
      if (ret==LCRZO_ERR_OK)
      { lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, de.device, 
                                          LCRZO_TRUE, hwtype, 
                                          LCRZO_TRUE, etha, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));
      }
      else
      { lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, de.device, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));
      }
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_complete_ip(void);
int lcrzo_priv_conf_incomplete_complete_ip(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_devices cd;
  lcrzo_int32 ci, ccount, i;
  lcrzo_bool found;
  lcrzo_ipl ip;
  lcrzo_hs hs;
  struct hostent *phe;
  int ret;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &ccount));

  /* get the local hostname */
  ret=gethostname(hs, LCRZO_HS_MAXBYTES);
  if (ret!=0) return(LCRZO_ERR_OKUNRESOLVED);
  /* get the corresponding IP addresses */
  phe=gethostbyname(hs);
  if (phe==NULL) return(LCRZO_ERR_OKUNRESOLVED);
  if (phe->h_addrtype!=AF_INET) return(LCRZO_ERR_OKUNRESOLVED);
  if (phe->h_length!=LCRZO_IPA_MAXBYTES) return(LCRZO_ERR_OKUNRESOLVED);

  /* loop through each device */
  i=0;
  while ( phe->h_addr_list[i] != NULL )
  { ip=((lcrzo_uint8)phe->h_addr_list[i][0])<<24;
    ip|=((lcrzo_uint8)phe->h_addr_list[i][1])<<16;
    ip|=((lcrzo_uint8)phe->h_addr_list[i][2])<<8;
    ip|=((lcrzo_uint8)phe->h_addr_list[i][3]);
    found=LCRZO_FALSE;
    for ( ci=1 ; ci<=ccount ; ci++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, ci, &cd));
      if ( cd.ip==ip )
      { found=LCRZO_TRUE;
        break;
      }
    }
    if (!found)
    { lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));
    }
    i++;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_complete_ras(void);
int lcrzo_priv_conf_incomplete_complete_ras(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_devices cd;
  lcrzo_int32 ci, ccount;
  lcrzo_bool found;
  lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_uint32 connectionnumber, i;
  lcrzo_ipl ip, ptpipl;
  lcrzo_etha etha;
  RASCONN *prasconn;
  RASPPPIP raspppip;
  int err, ret;

  if (!lcrzo_global_dll_rasapi32.isloaded) return(LCRZO_ERR_OK);

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_system_devices, &ccount));
  lcrzo_er(lcrzo_etha_initdefault(etha));
  datasize=LCRZO_PRIV_CONF_WINRAS_MAXCON*sizeof(RASCONN);
  lcrzo_er(lcrzo_data_alloc(datasize, &data));
  prasconn=(RASCONN*)data;
  prasconn->dwSize=sizeof(RASCONN);
  connectionnumber=0;
  err=lcrzo_global_dll_rasapi32.RasEnumConnections(prasconn, (lcrzo_uint32*)&datasize, &connectionnumber);
  if (!err)
  { /* loop through each connection */
    for ( i=0 ; i<connectionnumber ; i++ )
    { raspppip.dwSize=sizeof(RASPPPIP);
      datasize=sizeof(RASPPPIP);
      err=lcrzo_global_dll_rasapi32.RasGetProjectionInfo(prasconn[i].hrasconn, RASP_PppIp, &raspppip, (lcrzo_uint32*)&datasize);
      if (!err)
      { ret=lcrzo_ipl_init_ips(raspppip.szIpAddress, &ip);
        if (ret==LCRZO_ERR_OK)
        { ret=lcrzo_ipl_init_ips(raspppip.szServerIpAddress, &ptpipl);
          if (ret==LCRZO_ERR_OK)
          { 
            /* try to find it */
            found=LCRZO_FALSE;
            for ( ci=1 ; ci<=ccount ; ci++ )
            { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_system_devices, ci, &cd));
              if ( cd.ip==ip )
              { found=LCRZO_TRUE;
                break;
              }
            }
            if (!found)
            { lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_TRUE, LCRZO_DEVICE_HWTYPE_PPP, 
                                          LCRZO_TRUE, etha, 
                                          LCRZO_TRUE, ip, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_TRUE, LCRZO_FALSE,
                                          LCRZO_TRUE, LCRZO_TRUE,
                                          LCRZO_TRUE, ptpipl));
            }
          }
        }
      }
    }
  }
  lcrzo_er(lcrzo_data_free2(&data));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_conflictpower(lcrzo_priv_conf_incomplete *plpci);
int lcrzo_priv_conf_incomplete_conflictpower(lcrzo_priv_conf_incomplete *plpci)
{ lcrzo_int32 sum;

  sum=0;
  if (plpci->devicenumberset) sum++;
  if (plpci->deviceset) sum++;
  if (plpci->hwtypeset) sum++;
  if (plpci->ethset) sum++;
  if (plpci->ipset) sum++;
  if (plpci->netmaskset) sum++;
  if (plpci->mtuset) sum++;
  if (plpci->isupset) sum++;
  if (plpci->isanaliasset) sum++;
  if (plpci->ispointtopointset) sum++;
  if (plpci->pointtopointiplset) sum++;

  plpci->conflictpower=sum;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_addsys(lcrzo_priv_conf_incomplete lpci);
int lcrzo_priv_conf_incomplete_addsys(lcrzo_priv_conf_incomplete lpci)
{
  if ( lpci.devicenumberset && lpci.deviceset )
  { lcrzo_er(lcrzo_priv_conf_devicenumbername_item_add(lpci.devicenumber, lpci.device));
  }

  if (!lpci.devicenumberset)
  { lcrzo_er(lcrzo_uint32_init_rand(1000, 0xFFFFFFFFu, &lpci.devicenumber));
  }

  if (!lpci.deviceset)
  { lcrzo_er(lcrzo_string_init_uint32(lpci.devicenumber, "%u",
				      LCRZO_DEVICE_MAXBYTES,
				      lpci.device));
  }

  if (!lpci.hwtypeset)
    lpci.hwtype=LCRZO_DEVICE_HWTYPE_UNKNOWN;

  if (!lpci.ethset)
  { lcrzo_er(lcrzo_etha_initdefault(lpci.eth));
  }

  if (!lpci.ipset)
  { lpci.ip=0;
    lpci.netmaskset=LCRZO_TRUE;
    lpci.netmask=0;
  }

  if (!lpci.netmaskset)
  { if ((lpci.ip&0x80000000u)==0) lpci.netmask=0xFF000000u;
		else if ((lpci.ip&0xC0000000u)==0x80000000u) lpci.netmask=0xFFFF0000u;
		else if ((lpci.ip&0xE0000000u)==0xC0000000u) lpci.netmask=0xFFFFFF00u;
		else lpci.netmask=0xFFFFFF00u;
  }

  if (!lpci.mtuset)
    lpci.mtu=1500;

  if (!lpci.isupset)
    lpci.isup=LCRZO_TRUE;

  if (!lpci.isanaliasset)
    lpci.isanalias=LCRZO_FALSE;

  if (!lpci.ispointtopointset)
    lpci.ispointtopoint=LCRZO_FALSE;

  if (!lpci.pointtopointiplset)
    lpci.pointtopointipl=0;

  lcrzo_er(lcrzo_priv_conf_devices_add_system(lpci.device, lpci.hwtype,
					      lpci.eth, 
					      lpci.ip, lpci.netmask, lpci.mtu, 
					      lpci.isup, lpci.isanalias, 
					      lpci.ispointtopoint,
					      lpci.pointtopointipl));

  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_merge(lcrzo_priv_conf_incomplete lpci1,
                                     lcrzo_priv_conf_incomplete lpci2,
                                     lcrzo_priv_conf_incomplete *plpci);
int lcrzo_priv_conf_incomplete_merge(lcrzo_priv_conf_incomplete lpci1,
                                     lcrzo_priv_conf_incomplete lpci2,
                                     lcrzo_priv_conf_incomplete *plpci)
{ lcrzo_bool newisthewinner;

  /* first determine who is the winner on conflicts */
  lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpci1));
  lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpci2));
  if ( lpci2.conflictpower >= lpci1.conflictpower ) newisthewinner=LCRZO_FALSE;
  else newisthewinner=LCRZO_TRUE;

  *plpci=lpci1;

  if (lpci2.devicenumberset && ( !lpci1.devicenumberset || newisthewinner) )
  { plpci->devicenumber=lpci2.devicenumber;
    plpci->devicenumberset=LCRZO_TRUE;
  }

  if (lpci2.deviceset && ( !lpci1.deviceset || newisthewinner) )
  { lcrzo_er(lcrzo_device_init(lpci2.device, plpci->device));
    plpci->deviceset=LCRZO_TRUE;
  }

  if (lpci2.hwtypeset && ( !lpci1.hwtypeset || newisthewinner) )
  { plpci->hwtype=lpci2.hwtype;
    plpci->hwtypeset=LCRZO_TRUE;
  }

  if (lpci2.ethset && ( !lpci1.ethset || newisthewinner) )
  { lcrzo_er(lcrzo_etha_init_etha(lpci2.eth, plpci->eth));
    plpci->ethset=LCRZO_TRUE;
  }

  if (lpci2.ipset && ( !lpci1.ipset || newisthewinner) )
  { plpci->ip=lpci2.ip;
    plpci->ipset=LCRZO_TRUE;
  }

  if (lpci2.netmaskset && ( !lpci1.netmaskset || newisthewinner) )
  { plpci->netmask=lpci2.netmask;
    plpci->netmaskset=LCRZO_TRUE;
  }

  if (lpci2.mtuset && ( !lpci1.mtuset || newisthewinner) )
  { plpci->mtu=lpci2.mtu;
    plpci->mtuset=LCRZO_TRUE;
  }

  if (lpci2.isupset && ( !lpci1.isupset || newisthewinner) )
  { plpci->isup=lpci2.isup;
    plpci->isupset=LCRZO_TRUE;
  }

  if (lpci2.isanaliasset && ( !lpci1.isanaliasset || newisthewinner) )
  { plpci->isanalias=lpci2.isanalias;
    plpci->isanaliasset=LCRZO_TRUE;
  }

  if (lpci2.ispointtopointset && ( !lpci1.ispointtopointset || newisthewinner) )
  { plpci->ispointtopoint=lpci2.ispointtopoint;
    plpci->ispointtopointset=LCRZO_TRUE;
  }

  if (lpci2.pointtopointiplset && ( !lpci1.pointtopointiplset || newisthewinner) )
  { plpci->pointtopointipl=lpci2.pointtopointipl;
    plpci->pointtopointiplset=LCRZO_TRUE;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_ip(void);
int lcrzo_priv_conf_incomplete_simplify_ip(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci, lpci2, lpcitmp;
  lcrzo_int32 i, j, count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    if ( lpci.ipset )
    {
      for ( j=i+1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.ipset && lpci.ip==lpci2.ip )
        { lcrzo_er(lcrzo_priv_conf_incomplete_merge(lpci, lpci2, &lpcitmp));
          lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, i, &lpcitmp));
          lcrzo_er(lcrzo_list_remove_pos(&ptrcv->list_incomplete, j));
          count--;
          j--;
        }
      }
    }
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_devicenumber2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci);
int lcrzo_priv_conf_incomplete_simplify_devicenumber2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci)
{ lcrzo_bool newisthewinner;

  /* first determine who is the winner on conflicts */
  lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpci));
  if ( plpci->conflictpower >= lpci.conflictpower ) newisthewinner=LCRZO_FALSE;
  else
  { plpci->conflictpower=lpci.conflictpower;
    newisthewinner=LCRZO_TRUE;
  }

  if (lpci.deviceset)
  {
    if ( !plpci->deviceset || (plpci->deviceset && newisthewinner) )
    { lcrzo_er(lcrzo_device_init(lpci.device, plpci->device));
      plpci->deviceset=LCRZO_TRUE;
    }
  }

  if (lpci.hwtypeset)
  {
    if ( !plpci->hwtypeset || (plpci->hwtypeset && newisthewinner) )
    { plpci->hwtype=lpci.hwtype;
      plpci->hwtypeset=LCRZO_TRUE;
    }
  }

  if (lpci.ethset)
  {
    if ( !plpci->ethset || (plpci->ethset && newisthewinner) )
    { lcrzo_er(lcrzo_etha_init_etha(lpci.eth, plpci->eth));
      plpci->ethset=LCRZO_TRUE;
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_devicenumber3(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpciref);
int lcrzo_priv_conf_incomplete_simplify_devicenumber3(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpciref)
{ 
  if (lpciref.deviceset)
  { lcrzo_er(lcrzo_device_init(lpciref.device, plpci->device));
    plpci->deviceset=LCRZO_TRUE;
  }

  if (lpciref.hwtypeset)
  { plpci->hwtype=lpciref.hwtype;
    plpci->hwtypeset=LCRZO_TRUE;
  }

  if (lpciref.ethset)
  { lcrzo_er(lcrzo_etha_init_etha(lpciref.eth, plpci->eth));
    plpci->ethset=LCRZO_TRUE;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_devicenumber(void);
int lcrzo_priv_conf_incomplete_simplify_devicenumber(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci, lpci2, lpciref;
  lcrzo_int32 i, j, count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    if ( lpci.devicenumberset &&
         ( lpci.deviceset || lpci.hwtypeset || lpci.ethset ) )
    { /* determine associated values */
      lpciref=lpci;
      lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpciref));
      for ( j=1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.devicenumberset && lpci.devicenumber==lpci2.devicenumber )
        { lcrzo_er(lcrzo_priv_conf_incomplete_simplify_devicenumber2(&lpciref, lpci2));
        }
      }
      /* now use the reference */
      for ( j=1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.devicenumberset && lpci.devicenumber==lpci2.devicenumber )
        { lcrzo_er(lcrzo_priv_conf_incomplete_simplify_devicenumber3(&lpci2, lpciref));
          lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, j, &lpci2));
        }
      }
    }
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_device2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci);
int lcrzo_priv_conf_incomplete_simplify_device2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci)
{ lcrzo_bool newisthewinner;

  /* first determine who is the winner on conflicts */
  lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpci));
  if ( plpci->conflictpower >= lpci.conflictpower ) newisthewinner=LCRZO_FALSE;
  else
  { plpci->conflictpower=lpci.conflictpower;
    newisthewinner=LCRZO_TRUE;
  }

  if (lpci.devicenumberset)
  {
    if ( !plpci->devicenumberset || (plpci->devicenumberset && newisthewinner) )
    { plpci->devicenumber=lpci.devicenumber;
      plpci->devicenumberset=LCRZO_TRUE;
    }
  }

  if (lpci.hwtypeset)
  {
    if ( !plpci->hwtypeset || (plpci->hwtypeset && newisthewinner) )
    { plpci->hwtype=lpci.hwtype;
      plpci->hwtypeset=LCRZO_TRUE;
    }
  }

  if (lpci.ethset)
  {
    if ( !plpci->ethset || (plpci->ethset && newisthewinner) )
    { lcrzo_er(lcrzo_etha_init_etha(lpci.eth, plpci->eth));
      plpci->ethset=LCRZO_TRUE;
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_device3(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpciref);
int lcrzo_priv_conf_incomplete_simplify_device3(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpciref)
{ 
  if (lpciref.devicenumberset)
  { plpci->devicenumber=lpciref.devicenumber;
    plpci->devicenumberset=LCRZO_TRUE;
  }

  if (lpciref.hwtypeset)
  { plpci->hwtype=lpciref.hwtype;
    plpci->hwtypeset=LCRZO_TRUE;
  }

  if (lpciref.ethset)
  { lcrzo_er(lcrzo_etha_init_etha(lpciref.eth, plpci->eth));
    plpci->ethset=LCRZO_TRUE;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_device(void);
int lcrzo_priv_conf_incomplete_simplify_device(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci, lpci2, lpciref;
  lcrzo_int32 i, j, count;
  lcrzo_bool deviceequal;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    if ( lpci.deviceset &&
         ( lpci.devicenumberset || lpci.hwtypeset || lpci.ethset ) )
    { /* determine associated values */
      lpciref=lpci;
      lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpciref));
      for ( j=1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.deviceset )
        { lcrzo_er(lcrzo_device_equal2(lpci.device,lpci2.device, &deviceequal));
          if ( deviceequal )
          { lcrzo_er(lcrzo_priv_conf_incomplete_simplify_device2(&lpciref,
							       lpci2));
          }
        }
      }
      /* now use the reference */
      for ( j=1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.deviceset )
        { lcrzo_er(lcrzo_device_equal2(lpci.device,lpci2.device, &deviceequal));
          if ( deviceequal )
          { lcrzo_er(lcrzo_priv_conf_incomplete_simplify_device3(&lpci2,
							       lpciref));
            lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, j, &lpci2));
          }
        }
      }
    }
  }
  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_eth2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci);
int lcrzo_priv_conf_incomplete_simplify_eth2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci)
{ lcrzo_bool newisthewinner;

  /* first determine who is the winner on conflicts */
  lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpci));
  if ( plpci->conflictpower >= lpci.conflictpower ) newisthewinner=LCRZO_FALSE;
  else
  { plpci->conflictpower=lpci.conflictpower;
    newisthewinner=LCRZO_TRUE;
  }

  if (lpci.devicenumberset)
  {
    if ( !plpci->devicenumberset || (plpci->devicenumberset && newisthewinner) )
    { plpci->devicenumber=lpci.devicenumber;
      plpci->devicenumberset=LCRZO_TRUE;
    }
  }

  if (lpci.deviceset)
  {
    if ( !plpci->deviceset || (plpci->deviceset && newisthewinner) )
    { lcrzo_er(lcrzo_device_init(lpci.device, plpci->device));
      plpci->deviceset=LCRZO_TRUE;
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_eth3(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpciref);
int lcrzo_priv_conf_incomplete_simplify_eth3(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpciref)
{ 
  if (lpciref.devicenumberset)
  { plpci->devicenumber=lpciref.devicenumber;
    plpci->devicenumberset=LCRZO_TRUE;
  }

  if (lpciref.deviceset)
  { lcrzo_er(lcrzo_device_init(lpciref.device, plpci->device));
    plpci->deviceset=LCRZO_TRUE;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_eth(void);
int lcrzo_priv_conf_incomplete_simplify_eth(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci, lpci2, lpciref;
  lcrzo_int32 i, j, count;
  lcrzo_bool ethequal;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    if ( lpci.hwtypeset && lpci.hwtype==LCRZO_DEVICE_HWTYPE_ETHER && lpci.ethset &&
         ( lpci.devicenumberset || lpci.deviceset ) )
    { /* determine associated values */
      lpciref=lpci;
      lcrzo_er(lcrzo_priv_conf_incomplete_conflictpower(&lpciref));
      for ( j=1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.hwtypeset && lpci2.ethset )
        { lcrzo_er(lcrzo_etha_equal2(lpci.eth, lpci2.eth, &ethequal));
          if ( ethequal )
          { lcrzo_er(lcrzo_priv_conf_incomplete_simplify_eth2(&lpciref, lpci2));
          }
        }
      }
      /* now use the reference */
      for ( j=1 ; j<=count ; j++ )
      { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
        if ( lpci2.hwtypeset && lpci2.hwtype==LCRZO_DEVICE_HWTYPE_ETHER &&
             lpci2.ethset )
        { lcrzo_er(lcrzo_etha_equal2(lpci.eth, lpci2.eth, &ethequal));
          if ( ethequal )
          { lcrzo_er(lcrzo_priv_conf_incomplete_simplify_eth3(&lpci2, lpciref));
            lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, j, &lpci2));
          }
        }
      }
    }
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_doubles2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci,
                                            lcrzo_bool *pchange);
int lcrzo_priv_conf_incomplete_simplify_doubles2(lcrzo_priv_conf_incomplete *plpci,
                                            lcrzo_priv_conf_incomplete lpci,
                                            lcrzo_bool *pchange)
{ lcrzo_bool somethingcommon, equal;

  *pchange=LCRZO_FALSE;
  somethingcommon=LCRZO_FALSE;

  if ( plpci->devicenumberset && lpci.devicenumberset )
  { if ( plpci->devicenumber != lpci.devicenumber ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }
  if ( plpci->deviceset && lpci.deviceset )
  { lcrzo_er(lcrzo_device_equal2(plpci->device, lpci.device, &equal));
    if ( !equal ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }
  if ( plpci->hwtypeset && lpci.hwtypeset )
  { if ( plpci->hwtype != lpci.hwtype ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }
  if ( plpci->ethset && lpci.ethset )
  { lcrzo_er(lcrzo_etha_equal2(plpci->eth, lpci.eth, &equal));
    if ( !equal ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }
  if ( plpci->ipset && lpci.ipset )
  { if ( plpci->ip != lpci.ip ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }
  if ( plpci->netmaskset && lpci.netmaskset )
  { if ( plpci->netmask != lpci.netmask ) return(LCRZO_ERR_OK);
  }
  if ( plpci->mtuset && lpci.mtuset )
  { if ( plpci->mtu != lpci.mtu ) return(LCRZO_ERR_OK);
  }
  if ( plpci->isupset && lpci.isupset )
  { if ( plpci->isup != lpci.isup ) return(LCRZO_ERR_OK);
  }
  if ( plpci->isanaliasset && lpci.isanaliasset )
  { if ( plpci->isanalias != lpci.isanalias ) return(LCRZO_ERR_OK);
  }
  if ( plpci->ispointtopointset && lpci.ispointtopointset )
  { if ( plpci->ispointtopoint != lpci.ispointtopoint ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }
  if ( plpci->pointtopointiplset && lpci.pointtopointiplset )
  { if ( plpci->pointtopointipl != lpci.pointtopointipl ) return(LCRZO_ERR_OK);
    somethingcommon=LCRZO_TRUE;
  }

  if (!somethingcommon) return(LCRZO_ERR_OK);

  /* they correspond : update plpci */
  *pchange=LCRZO_TRUE;
  if (lpci.devicenumberset)
  { plpci->devicenumber=lpci.devicenumber;
    plpci->devicenumberset=LCRZO_TRUE;
  }
  if (lpci.deviceset)
  { lcrzo_er(lcrzo_device_init(lpci.device, plpci->device));
    plpci->deviceset=LCRZO_TRUE;
  }
  if (lpci.hwtypeset)
  { plpci->hwtype=lpci.hwtype;
    plpci->hwtypeset=LCRZO_TRUE;
  }
  if (lpci.ethset)
  { lcrzo_er(lcrzo_etha_init_etha(lpci.eth, plpci->eth));
    plpci->ethset=LCRZO_TRUE;
  }
  if (lpci.ipset)
  { plpci->ip=lpci.ip;
    plpci->ipset=LCRZO_TRUE;
  }
  if (lpci.netmaskset)
  { plpci->netmask=lpci.netmask;
    plpci->netmaskset=LCRZO_TRUE;
  }
  if (lpci.mtuset)
  { plpci->mtu=lpci.mtu;
    plpci->mtuset=LCRZO_TRUE;
  }
  if (lpci.isupset)
  { plpci->isup=lpci.isup;
    plpci->isupset=LCRZO_TRUE;
  }
  if (lpci.isanaliasset)
  { plpci->isanalias=lpci.isanalias;
    plpci->isanaliasset=LCRZO_TRUE;
  }
  if (lpci.ispointtopointset)
  { plpci->ispointtopoint=lpci.ispointtopoint;
    plpci->ispointtopointset=LCRZO_TRUE;
  }
  if (lpci.pointtopointiplset)
  { plpci->pointtopointipl=lpci.pointtopointipl;
    plpci->pointtopointiplset=LCRZO_TRUE;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_simplify_doubles(void);
int lcrzo_priv_conf_incomplete_simplify_doubles(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci, lpci2;
  lcrzo_int32 i, j, count;
  lcrzo_bool change;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    for ( j=i+1 ; j<=count ; j++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpci2));
      lcrzo_er(lcrzo_priv_conf_incomplete_simplify_doubles2(&lpci, lpci2, &change));
      if (change)
      { lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, i, &lpci));
        lcrzo_er(lcrzo_list_remove_pos(&ptrcv->list_incomplete, j));
        count--;
        j--;
      }
    }
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_entriesok2(lcrzo_priv_conf_incomplete lpci,
                                          lcrzo_bool *pdeleteit);
int lcrzo_priv_conf_incomplete_entriesok2(lcrzo_priv_conf_incomplete lpci,
                                          lcrzo_bool *pdeleteit)
{ 
  *pdeleteit=LCRZO_FALSE;

  if ( !lpci.devicenumberset && !lpci.deviceset && !lpci.ipset )
  { /* remove unusable entries */
    *pdeleteit=LCRZO_TRUE;
    return(LCRZO_ERR_OK);
  }

  if ( !lpci.deviceset || !lpci.ipset ) return(LCRZO_ERR_OK);

  lcrzo_er(lcrzo_priv_conf_incomplete_addsys(lpci));
  *pdeleteit=LCRZO_TRUE;

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_entriesok(void);
int lcrzo_priv_conf_incomplete_entriesok(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci;
  lcrzo_int32 i, count;
  lcrzo_bool deleteit;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    lcrzo_er(lcrzo_priv_conf_incomplete_entriesok2(lpci, &deleteit));
    if (deleteit)
    { lcrzo_er(lcrzo_list_remove_pos(&ptrcv->list_incomplete, i));
      count--;
      i--;
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_guess_devnumdev(void);
int lcrzo_priv_conf_incomplete_guess_devnumdev(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpcidevice, lpcidevnum, lpcitmp;
  lcrzo_int32 i, j, count;
  lcrzo_uint32 currentdevicenumber;
  lcrzo_bool found;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));

  lpcidevice.isup=LCRZO_FALSE; /* for the compiler warning */
  lpcidevnum.isup=LCRZO_FALSE; /* for the compiler warning */
  currentdevicenumber=0; /* for the compiler warning */
  while (LCRZO_TRUE)
  { found=LCRZO_FALSE;
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpcidevnum));
      if ( lpcidevnum.devicenumberset && !lpcidevnum.deviceset )
      { found=LCRZO_TRUE;
        currentdevicenumber=lpcidevnum.devicenumber;
        break;
      }
    }
    if (!found)
    { /* there is no more devicenumber, stop */
      return(LCRZO_ERR_OK);
    }
    found=LCRZO_FALSE;
    for ( j=1 ; j<=count ; j++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpcidevice));
      if ( !lpcidevice.devicenumberset && lpcidevice.deviceset )
      { found=LCRZO_TRUE;
        break;
      }
    }
    if (!found)
    { /* there is no more device, stop */
      return(LCRZO_ERR_OK);
    }
    /* merge entries */
    lcrzo_er(lcrzo_priv_conf_incomplete_merge(lpcidevice, lpcidevnum, &lpcitmp));
    lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, i, &lpcitmp));
    lcrzo_er(lcrzo_list_remove_pos(&ptrcv->list_incomplete, j));
    count--;
    /* search in case we have other entries with this devicenumber */
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpcidevnum));
      if ( lpcidevnum.devicenumberset && !lpcidevnum.deviceset &&
           lpcidevnum.devicenumber==currentdevicenumber )
      { lcrzo_er(lcrzo_priv_conf_incomplete_merge(lpcidevice, lpcidevnum, &lpcitmp));
        lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, i, &lpcitmp));
      }
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_guess_devip(void);
int lcrzo_priv_conf_incomplete_guess_devip(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpcidevice, lpciip, lpcitmp;
  lcrzo_int32 i, j, count;
  lcrzo_bool found;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));

  lpcidevice.isup=LCRZO_FALSE; /* for the compiler warning */
  lpciip.isup=LCRZO_FALSE; /* for the compiler warning */
  while (LCRZO_TRUE)
  { found=LCRZO_FALSE;
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpcidevice));
      if ( lpcidevice.deviceset && !lpcidevice.ipset )
      { found=LCRZO_TRUE;
        break;
      }
    }
    if (!found)
    { /* there is no more devices, stop */
      return(LCRZO_ERR_OK);
    }
    found=LCRZO_FALSE;
    for ( j=1 ; j<=count ; j++ )
    { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, j, &lpciip));
      if ( !lpciip.deviceset && lpciip.ipset )
      { found=LCRZO_TRUE;
        break;
      }
    }
    if (!found)
    { /* there is no more ip, stop */
      return(LCRZO_ERR_OK);
    }
    /* merge entries */
    lcrzo_er(lcrzo_priv_conf_incomplete_merge(lpcidevice, lpciip, &lpcitmp));
    lcrzo_er(lcrzo_list_replace_pos(&ptrcv->list_incomplete, i, &lpcitmp));
    lcrzo_er(lcrzo_list_remove_pos(&ptrcv->list_incomplete, j));
    count--;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_guess_device(void);
int lcrzo_priv_conf_incomplete_guess_device(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_incomplete lpci;
  lcrzo_int32 i, count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));

  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_incomplete, i, &lpci));
    if (lpci.deviceset)
    { lcrzo_er(lcrzo_priv_conf_incomplete_addsys(lpci));
      lcrzo_er(lcrzo_list_remove_pos(&ptrcv->list_incomplete, i));
      count--;
      i--;
    }
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_job_before(void);
int lcrzo_priv_conf_incomplete_job_before(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_remove_all(&ptrcv->list_incomplete));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_job_after(void);
int lcrzo_priv_conf_incomplete_job_after(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_int32 count;

  lcrzo_er(lcrzo_priv_conf_incomplete_complete_dev());
  lcrzo_er(lcrzo_priv_conf_incomplete_complete_ip());
  lcrzo_er(lcrzo_priv_conf_incomplete_complete_ras());
  
  /* stop here if we have nothing */
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_incomplete, &count));
  if (count==0) return(LCRZO_ERR_OK);

  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_ip());
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_devicenumber());
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_device());
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_eth());
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_doubles());

  lcrzo_er(lcrzo_priv_conf_incomplete_entriesok());

  lcrzo_er(lcrzo_priv_conf_incomplete_guess_devnumdev());
  lcrzo_er(lcrzo_priv_conf_incomplete_entriesok());

  lcrzo_er(lcrzo_priv_conf_incomplete_guess_devip());
  lcrzo_er(lcrzo_priv_conf_incomplete_entriesok());

  lcrzo_er(lcrzo_priv_conf_incomplete_guess_device());
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_incomplete_job_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_incomplete_job_debug_fprint(LCRZOFILE *pf)
{ 
  fprintf(pf, "\n\nEntries in list_incomplete\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

/*
  { lcrzo_etha etha;
    lcrzo_er(lcrzo_priv_conf_incomplete_add_4(33, 0x03040506));
    lcrzo_er(lcrzo_priv_conf_incomplete_add_4(34, 0x03040506));
    lcrzo_er(lcrzo_priv_conf_incomplete_add_5("lc", 0x03040506, 0xFF000000, LCRZO_TRUE));
    lcrzo_er(lcrzo_etha_init(1,2,3,4,5,6, etha));
    lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, "lc", 
                                          LCRZO_TRUE, LCRZO_DEVICE_HWTYPE_ETHER, 
                                          LCRZO_TRUE, etha, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));
    lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_TRUE, 34, 
                                          LCRZO_TRUE, "lcr", 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, NULL, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));
    lcrzo_er(lcrzo_etha_init(1,2,3,4,5,7, etha));
    lcrzo_er(lcrzo_priv_conf_incomplete_add_3(34, LCRZO_DEVICE_HWTYPE_ETHER, etha, 0x56788765));
    lcrzo_er(lcrzo_etha_init(1,2,3,4,5,8, etha));
    lcrzo_er(lcrzo_priv_conf_incomplete_add_3(35, LCRZO_DEVICE_HWTYPE_ETHER, etha, 0x56788766));
    lcrzo_er(lcrzo_priv_conf_incomplete_add(LCRZO_FALSE, 0, 
                                          LCRZO_TRUE, "lcrzo", 
                                          LCRZO_TRUE, LCRZO_DEVICE_HWTYPE_ETHER, 
                                          LCRZO_TRUE, etha, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0, 
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0,
                                          LCRZO_FALSE, 0));
  }
  */

  fprintf(pf, "\n\nEntries in list_incomplete after complete_dev\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_complete_dev());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after complete_ip\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_complete_ip());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after complete_ras\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_complete_ras());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

  fprintf(pf, "\n\nEntries in list_incomplete after simplify_ip\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_ip());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after simplify_devicenumber\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_devicenumber());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after simplify_device\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_device());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after simplify_eth\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_eth());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after simplify_doubles\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_simplify_doubles());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

  fprintf(pf, "\n\nEntries in list_incomplete after entriesok\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_entriesok());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

  fprintf(pf, "\n\nEntries in list_incomplete after guess_devnumdev\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_guess_devnumdev());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after entriesok\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_entriesok());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

  fprintf(pf, "\n\nEntries in list_incomplete after guess_devip\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_guess_devip());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));
  fprintf(pf, "\n\nEntries in list_incomplete after entriesok\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_entriesok());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

  fprintf(pf, "\n\nEntries in list_incomplete after guess_device\n");
  lcrzo_er(lcrzo_priv_conf_incomplete_guess_device());
  lcrzo_er(lcrzo_priv_conf_incomplete_debug_fprint(pf));

  fprintf(pf, "\n");
  return(LCRZO_ERR_OK);
}

#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
