/* This file is part of Lcrzo.
*/

/* This file is part of Lcrzo.
*/

#ifdef LCRZODEF_SYSTEM_Unix
  /* this function is not needed*/

#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localdevice_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_localdevice_debug_fprint(LCRZOFILE *pf)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_priv_conf_deviceeth de;
  lcrzo_int32 i, count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_localdevice, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_er(lcrzo_list_value_pos(&ptrcv->list_localdevice, i, &de));
    lcrzo_er(lcrzo_device_fprint(pf, " dev=", de.device, "\n"));
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localdevice_init(void);
int lcrzo_priv_conf_localdevice_init(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_bool isunicode;
  lcrzo_priv_conf_deviceeth de;
  int start, end, ret;
  
  /* first, delete old entries set by uncomplete executions */
  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_remove_all(&ptrcv->list_localdevice));
 
  datasize=10000;
  lcrzo_er(lcrzo_data_alloc(datasize, &data));
  ret=lcrzo_priv_cs_PacketGetAdapterNames((lcrzo_string)data, (lcrzo_uint32 *)&datasize);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_er(lcrzo_data_free2(&data));
    return(ret);
  }
  /* unfortunately, on some cases, datasize is not updated to contain the true 
     size of data set by PacketGetAdapterNames */

  /* simple check if data is unicode */
  isunicode=LCRZO_FALSE;
  if ( data[1]==0 ) isunicode=LCRZO_TRUE;

  lcrzo_er(lcrzo_etha_initdefault(de.eth));

  /* loop for each adapter name */
  start=0;
  ret=LCRZO_ERR_OK;
  while(ret==LCRZO_ERR_OK)
  { /* find the end of adapter name */
    end=start;
    if (isunicode)
    { while( !(data[end]==0 && data[end+1]==0) && end<datasize ) end+=2;
    }
    else
    { while( data[end]!=0 && end<datasize ) end++;
    }
    /* end of list */
    if ( end==start || end==datasize ) break;
    /* add the device */
    if (isunicode)
    { ret=lcrzo_priv_device_init_unicode(data+start, de.device);
    }
    else
    { ret=lcrzo_priv_device_init_ascii((lcrzo_string)(data+start), de.device);
    }    
    if (ret==LCRZO_ERR_OK)
    { ret=lcrzo_list_add_last(&ptrcv->list_localdevice, &de);
    }
    /* skip this device */
    if (isunicode) start=end+2;
    else start=end+1;
  }

  lcrzo_er(lcrzo_data_free2(&data));
  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localdevice_eventuallyinit(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_int32 count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_localdevice, &count));
  if (count==0)
  { lcrzo_er(lcrzo_priv_conf_localdevice_init());
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localdevice_init_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_localdevice_init_debug_fprint(LCRZOFILE *pf)
{ 
  fprintf(pf, "\n\nEntries in list_localdevice\n");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localdevice_init(), "lcrzo_priv_conf_localdevice_init");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localdevice_debug_fprint(pf), "lcrzo_priv_conf_localdevice_debug_fprint");

  return(LCRZO_ERR_OK);
}

#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
