/* This file is part of Lcrzo.
*/

/* This file is part of Lcrzo.
*/

#ifdef LCRZODEF_SYSTEM_Unix
  /* this function is not needed*/

#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_localip_debug_fprint(LCRZOFILE *pf)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_ipl ip;
  int ret;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  ret=lcrzo_iplist_value_first(&ptrcv->list_localip, &ip);
  if (ret==LCRZO_ERR_OKDATAEND)
  { fprintf(pf, "Empty list\n");
    return(LCRZO_ERR_OK);
  }
  else if (ret!=LCRZO_ERR_OK)
  { return(ret);
  }
  while (LCRZO_TRUE)
  { lcrzo_er(lcrzo_ipl_fprint(pf, " ip=", ip, "\n"));
    ret=lcrzo_iplist_value_next(&ptrcv->list_localip, ip, &ip);
    if (ret==LCRZO_ERR_OKDATAEND) break;
    else if (ret!=LCRZO_ERR_OK) return(ret);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_init_iphlpapi(void);
int lcrzo_priv_conf_localip_init_iphlpapi(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_uint32 bufsize, i;
  lcrzo_ipl ip;
  PMIB_IPADDRTABLE pipaddrtable;
  int ret;

  if (!lcrzo_global_dll_iphlpapi.isloaded) return(LCRZO_ERR_IEUNIMPLEMENTED);

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  /* first, delete old entries set by uncomplete executions */
  lcrzo_er(lcrzo_list_remove_all(&ptrcv->list_localip));

  /* get the IP table size */
  bufsize=0;
  ret=(lcrzo_global_dll_iphlpapi.GetIpAddrTable)(NULL, &bufsize, FALSE);
  if ( ret!=ERROR_INSUFFICIENT_BUFFER )
  { return(LCRZO_ERR_FUGETIPADDRTABLE);
  }
  lcrzo_er(lcrzo_priv_err_purge_int());

  /* allocate data */
  lcrzo_er(lcrzo_data_alloc(bufsize, (lcrzo_data*)&pipaddrtable));
  
  /* get the IP table */
  ret=lcrzo_global_dll_iphlpapi.GetIpAddrTable(pipaddrtable, &bufsize, FALSE);
  if ( ret!=NO_ERROR )
  { lcrzo_er(lcrzo_data_free2((lcrzo_data*)&pipaddrtable));
    return(LCRZO_ERR_FUGETIPADDRTABLE);
  }
  lcrzo_er(lcrzo_priv_err_purge_int());

  /* loop through each entry */
  for ( i=0 ; i<pipaddrtable->dwNumEntries && ret==LCRZO_ERR_OK ; i++ )
  { ip=lcrzo_htonl(pipaddrtable->table[i].dwAddr);
    if (ip!=0)
    { ret=lcrzo_iplist_add_range(&ptrcv->list_localip, ip, ip);
    }
  }

  lcrzo_er(lcrzo_data_free2((lcrzo_data*)&pipaddrtable));
  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_init_snmpdll(void);
int lcrzo_priv_conf_localip_init_snmpdll(void)
{ lcrzo_priv_dll_snmpreq snmpdllreqip;
  lcrzo_priv_confvars *ptrcv;
  AsnObjectIdentifier oid0;
  lcrzo_ipl ipaddress;
  unsigned int old;

  if (!lcrzo_global_dll_snmp.isloaded) return(LCRZO_ERR_IEUNIMPLEMENTED);

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  /* first, delete old entries set by uncomplete executions */
  lcrzo_er(lcrzo_list_remove_all(&ptrcv->list_localip));

  /* get characteristics of the IP addresses */
  lcrzo_er(lcrzo_priv_dll_snmpoid_init(&oid0, 1, 3, 6, 1, 2, 1, 4, 20, 1, 1, -1));
  lcrzo_er(lcrzo_priv_dll_snmpreq_init(&snmpdllreqip, &oid0, NULL, NULL, NULL, NULL));
  lcrzo_er(lcrzo_priv_dll_snmpoid_close(&oid0));
  lcrzo_er(lcrzo_priv_dll_snmpreq_getnext(&snmpdllreqip));
  old=0;
  while ( snmpdllreqip.varBindList.list[0].name.ids[7] == 20 &&
          snmpdllreqip.varBindList.list[0].name.ids[9] == 1 && 
          (unsigned int)snmpdllreqip.varBindList.list[0].name.ids[10] >= old )
  { /*lcrzo_er(lcrzo_priv_snmpdllreq_print(&snmpdllreqip));*/
    lcrzo_er(lcrzo_priv_dll_snmpreq__uint32(&snmpdllreqip, 0, &ipaddress));
    if (ipaddress!=0)
    { lcrzo_er(lcrzo_iplist_add_range(&ptrcv->list_localip, ipaddress, ipaddress));
    }
    old=snmpdllreqip.varBindList.list[0].name.ids[10];
    lcrzo_er(lcrzo_priv_dll_snmpreq_getnext(&snmpdllreqip));
  }

  /* end */
  lcrzo_er(lcrzo_priv_dll_snmpreq_close(&snmpdllreqip));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_init_gethostbyname(void);
int lcrzo_priv_conf_localip_init_gethostbyname(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_ipl ip;
  lcrzo_hs hs;
  struct hostent *phe;
  int ret, i;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  /* first, delete old entries set by uncomplete executions */
  lcrzo_er(lcrzo_list_remove_all(&ptrcv->list_localip));
 
  /* get the local hostname */
  ret=gethostname(hs, LCRZO_HS_MAXBYTES);
  if (ret!=0) return(LCRZO_ERR_OKUNRESOLVED);

  /* get the corresponding IP addresses */
  phe=gethostbyname(hs);
  if (phe==NULL) return(LCRZO_ERR_OKUNRESOLVED);
  if (phe->h_addrtype!=AF_INET) return(LCRZO_ERR_OKUNRESOLVED);
  if (phe->h_length!=LCRZO_IPA_MAXBYTES) return(LCRZO_ERR_OKUNRESOLVED);

  /* loop through each device */
  i=0;
  while ( phe->h_addr_list[i] != NULL )
  { ip=((lcrzo_uint8)phe->h_addr_list[i][0])<<24;
    ip|=((lcrzo_uint8)phe->h_addr_list[i][1])<<16;
    ip|=((lcrzo_uint8)phe->h_addr_list[i][2])<<8;
    ip|=((lcrzo_uint8)phe->h_addr_list[i][3]);
    if (ip!=0)
    { lcrzo_er(lcrzo_iplist_add_range(&ptrcv->list_localip, ip, ip));
    }
    i++;
  }

  /* add loopback */
  ip=0x7F000001;
  lcrzo_er(lcrzo_iplist_add_range(&ptrcv->list_localip, ip, ip));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_init(void);
int lcrzo_priv_conf_localip_init(void)
{ int ret;

  ret=lcrzo_priv_conf_localip_init_iphlpapi();
  if (ret!=LCRZO_ERR_OK)
  { ret=lcrzo_priv_conf_localip_init_snmpdll();
  }
  if (ret!=LCRZO_ERR_OK)
  { ret=lcrzo_priv_conf_localip_init_gethostbyname();
  }
  if (ret!=LCRZO_ERR_OK)
  { /* Could also use :
       - packet.dll with PacketGetNetInfo, but this function doesn't work properly
       - NT registry, but this function is currently not used under NT
       - Win registry, but result are incomplete because of DhcpInfoxx. Moreover,
         DhcpInfoxx are associated thanks to this function, so can not do a recursive loop
    */
  }

  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_eventuallyinit(void);
int lcrzo_priv_conf_localip_eventuallyinit(void)
{ lcrzo_priv_confvars *ptrcv;
  lcrzo_int32 count;

  lcrzo_er(lcrzo_priv_confvars_ptr_get(&ptrcv));
  lcrzo_er(lcrzo_list_count(&ptrcv->list_localip, &count));
  if (count==0)
  { lcrzo_er(lcrzo_priv_conf_localip_init());
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_localip_init_debug_fprint(LCRZOFILE *pf);
int lcrzo_priv_conf_localip_init_debug_fprint(LCRZOFILE *pf)
{ lcrzo_priv_confvars *ptrcv;

  lcrzo_erpcw1o(pf, lcrzo_priv_confvars_ptr_get(&ptrcv), "lcrzo_priv_confvars_ptr_get");

  fprintf(pf, "\n\nEntries in list_localip after lcrzo_priv_conf_localip_init\n");
  lcrzo_erpcw1o(pf, lcrzo_list_remove_all(&ptrcv->list_localip), "lcrzo_list_remove_all");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_init(), "lcrzo_priv_conf_localip_init");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_debug_fprint(pf), "lcrzo_priv_conf_localip_debug_fprint");

  fprintf(pf, "\n\nEntries in list_localip after lcrzo_priv_conf_localip_init_iphlpapi\n");
  lcrzo_erpcw1o(pf, lcrzo_list_remove_all(&ptrcv->list_localip), "lcrzo_list_remove_all");
  lcrzo_erpcw2o(pf, lcrzo_priv_conf_localip_init_iphlpapi(), "lcrzo_priv_conf_localip_init_iphlpapi", LCRZO_ERR_IEUNIMPLEMENTED);
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_debug_fprint(pf), "lcrzo_priv_conf_localip_debug_fprint");

  fprintf(pf, "\n\nEntries in list_localip after lcrzo_priv_conf_localip_init_snmpdll\n");
  lcrzo_erpcw1o(pf, lcrzo_list_remove_all(&ptrcv->list_localip), "lcrzo_list_remove_all");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_init_snmpdll(), "lcrzo_priv_conf_localip_init_snmpdll");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_debug_fprint(pf), "lcrzo_priv_conf_localip_debug_fprint");

  fprintf(pf, "\n\nEntries in list_localip after lcrzo_priv_conf_localip_init_gethostbyname\n");
  lcrzo_erpcw1o(pf, lcrzo_list_remove_all(&ptrcv->list_localip), "lcrzo_list_remove_all");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_init_gethostbyname(), "lcrzo_priv_conf_localip_init_gethostbyname");
  lcrzo_erpcw1o(pf, lcrzo_priv_conf_localip_debug_fprint(pf), "lcrzo_priv_conf_localip_debug_fprint");

  lcrzo_erpcw1o(pf, lcrzo_list_remove_all(&ptrcv->list_localip), "lcrzo_list_remove_all");
  return(LCRZO_ERR_OK);
}


#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
