/* This file is part of Lcrzo.
*/

/* This file is part of Lcrzo.
*/

#ifdef LCRZODEF_SYSTEM_Unix
  /* this function is not needed*/

#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_winras_getpeer(lcrzo_ipl ipl,
                                   lcrzo_int16 *phwtype,
                                   lcrzo_bool *pisptp,
                                   lcrzo_ipl *pptpipl);
int lcrzo_priv_conf_winras_getpeer(lcrzo_ipl ipl,
                                   lcrzo_int16 *phwtype,
                                   lcrzo_bool *pisptp,
                                   lcrzo_ipl *pptpipl)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_uint32 connectionnumber, i;
  lcrzo_ipl ip;
  RASCONN *prasconn;
  RASPPPIP raspppip;
  int err, ret;

  if (pisptp!=NULL) *pisptp=LCRZO_FALSE;
  if (pptpipl!=NULL) *pptpipl=0;

  if ( *phwtype!=LCRZO_DEVICE_HWTYPE_UNKNOWN &&
       *phwtype!=LCRZO_DEVICE_HWTYPE_PPP )
  { return(LCRZO_ERR_OK);
  }

  if (!lcrzo_global_dll_rasapi32.isloaded) return(LCRZO_ERR_OK);

  datasize=LCRZO_PRIV_CONF_WINRAS_MAXCON*sizeof(RASCONN);
  lcrzo_er(lcrzo_data_alloc(datasize, &data));
  prasconn=(RASCONN*)data;
  prasconn->dwSize=sizeof(RASCONN);
  connectionnumber=0;
  err=lcrzo_global_dll_rasapi32.RasEnumConnections(prasconn, (lcrzo_uint32*)&datasize, &connectionnumber);
  if (!err)
  { /* loop through each connection */
    /*printf("connectionnumber : %d\n", connectionnumber);*/
    for ( i=0 ; i<connectionnumber ; i++ )
    { /*printf("Entry name: %s\n", prasconn[i].szEntryName);*/
      raspppip.dwSize=sizeof(RASPPPIP);
      datasize=sizeof(RASPPPIP);
      err=lcrzo_global_dll_rasapi32.RasGetProjectionInfo(prasconn[i].hrasconn, RASP_PppIp, &raspppip, (lcrzo_uint32*)&datasize);
      if (!err)
      { /*printf("RAS %d : %s\n", i, raspppip.szIpAddress);*/
        ret=lcrzo_ipl_init_ips(raspppip.szIpAddress, &ip);
        if (ret==LCRZO_ERR_OK)
        {
          if (ip==ipl)
          { if (pisptp!=NULL) *pisptp=LCRZO_TRUE;
            if (phwtype!=NULL) *phwtype=LCRZO_DEVICE_HWTYPE_PPP;
            ret=lcrzo_ipl_init_ips(raspppip.szServerIpAddress, pptpipl);
	    if (ret==LCRZO_ERR_OK)
            { lcrzo_er(lcrzo_ipl_initdefault(pptpipl));
	    }
          }
        }
      }
    }
  }
  lcrzo_er(lcrzo_data_free2(&data));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_winras_devices_add_system(lcrzo_constdevice device,
				       lcrzo_int16 hwtype,
				       lcrzo_constetha etha,
				       lcrzo_ipl ipl,
				       lcrzo_ipl netmask,
				       lcrzo_uint32 mtu,
				       lcrzo_bool isup,
				       lcrzo_bool isanalias);
int lcrzo_priv_conf_winras_devices_add_system(lcrzo_constdevice device,
				       lcrzo_int16 hwtype,
				       lcrzo_constetha etha,
				       lcrzo_ipl ipl,
				       lcrzo_ipl netmask,
				       lcrzo_uint32 mtu,
				       lcrzo_bool isup,
				       lcrzo_bool isanalias)
{ lcrzo_ipl ptpipl;
  lcrzo_bool isptp;
  int ret;

  /* try to obtain peer */
  ret=lcrzo_priv_conf_winras_getpeer(ipl, &hwtype, &isptp, &ptpipl);
  if (ret!=LCRZO_ERR_OK)
  { isptp=LCRZO_FALSE;
    ptpipl=0;
  }

  /* add */
  ret=lcrzo_priv_conf_devices_add_system(device, hwtype, etha, ipl, netmask,
                                         mtu, isup, isanalias, isptp, ptpipl);

  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_winras_isarasip(lcrzo_ipl ipl,
                                    lcrzo_bool *pyes);
int lcrzo_priv_conf_winras_isarasip(lcrzo_ipl ipl,
                                    lcrzo_bool *pyes)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_uint32 connectionnumber, i;
  lcrzo_ipl ip;
  RASCONN *prasconn;
  RASPPPIP raspppip;
  int err, ret;

  if (!lcrzo_global_dll_rasapi32.isloaded)
  { if (pyes!=NULL) *pyes=LCRZO_FALSE;
    return(LCRZO_ERR_OK);
  }

  datasize=LCRZO_PRIV_CONF_WINRAS_MAXCON*sizeof(RASCONN);
  lcrzo_er(lcrzo_data_alloc(datasize, &data));
  prasconn=(RASCONN*)data;
  prasconn->dwSize=sizeof(RASCONN);
  connectionnumber=0;
  err=lcrzo_global_dll_rasapi32.RasEnumConnections(prasconn, (lcrzo_uint32*)&datasize, &connectionnumber);
  if (!err)
  { /* loop through each connection */
    /*printf("connectionnumber : %d\n", connectionnumber);*/
    for ( i=0 ; i<connectionnumber ; i++ )
    { /*printf("Entry name: %s\n", prasconn[i].szEntryName);*/
      raspppip.dwSize=sizeof(RASPPPIP);
      datasize=sizeof(RASPPPIP);
      err=lcrzo_global_dll_rasapi32.RasGetProjectionInfo(prasconn[i].hrasconn, RASP_PppIp, &raspppip, (lcrzo_uint32*)&datasize);
      if (!err)
      { /*printf("RAS %d : %s\n", i, raspppip.szIpAddress);*/
        ret=lcrzo_ipl_init_ips(raspppip.szIpAddress, &ip);
        if (ret==LCRZO_ERR_OK)
        {
          if (ip==ipl)
          { if (pyes!=NULL) *pyes=LCRZO_TRUE;
            lcrzo_er(lcrzo_data_free2(&data));
            return(LCRZO_ERR_OK);
          }
        }
      }
    }
  }
  lcrzo_er(lcrzo_data_free2(&data));

  if (pyes!=NULL) *pyes=LCRZO_FALSE;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_conf_winras_w95bugged(lcrzo_bool *pyes)
{ lcrzo_data data;
  lcrzo_priv_globalvars *ptrglo;
  lcrzo_int32 datasize;
  lcrzo_uint32 connectionnumber;
  RASCONN *prasconn;
  lcrzo_bool bugged;
  int err;

  lcrzo_er(lcrzo_priv_globalvars_ptr_get(&ptrglo));
  if ( ptrglo->windows_systemversion != LCRZO_WINDOWS_SYSTEMVERSION_95 )
  { if (pyes!=NULL) *pyes=LCRZO_FALSE;
    return(LCRZO_ERR_OK);
  }

  if (!lcrzo_global_dll_rasapi32.isloaded)
  { if (pyes!=NULL) *pyes=LCRZO_FALSE;
    return(LCRZO_ERR_OK);
  }

  datasize=LCRZO_PRIV_CONF_WINRAS_MAXCON*sizeof(RASCONN);
  lcrzo_er(lcrzo_data_alloc(datasize, &data));
  prasconn=(RASCONN*)data;
  prasconn->dwSize=sizeof(RASCONN);
  bugged=LCRZO_FALSE;
  err=lcrzo_global_dll_rasapi32.RasEnumConnections(prasconn,
						   (lcrzo_uint32*)&datasize,
						   &connectionnumber);
  if (!err)
  { if (connectionnumber)
      bugged=LCRZO_TRUE;
  }
  lcrzo_er(lcrzo_data_free2(&data));

  if (pyes!=NULL) *pyes=bugged;
  return(LCRZO_ERR_OK);
}

#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
