/* This file is part of Lcrzo.
*/

#if defined LCRZODEF_SYSTEM_Unix
 /* do no need these functions */
#elif defined LCRZODEF_SYSTEM_Windows
int lcrzo_priv_dll_init(void)
{ lcrzo_priv_globalvars *ptr;
  lcrzo_bool needtoload, supportsip;
  int ret;
  
  /* init winsock version 2.2  */
  lcrzo_er(lcrzo_priv_dll_winsock2_needtoload(&needtoload));
  if (needtoload)
  { /* init */
    ret=lcrzo_priv_dll_winsock2_init(&lcrzo_global_dll_winsock2);
    if (ret!=LCRZO_ERR_OK)
    { /* ensure it is not loaded */
      lcrzo_global_dll_winsock2.isloaded=LCRZO_FALSE;
    }
    /* now winsock2.2 is setup, we can decide to change useethforip,
       which is set by default */
    lcrzo_er(lcrzo_priv_spoof_supports_ip(&supportsip));
    if (supportsip)
    { lcrzo_er(lcrzo_priv_globalvars_ptr_get(&ptr));
      ptr->spoof_useethforip=LCRZO_FALSE;
    }
  }

  /* init RAS api */
  ret=lcrzo_priv_dll_rasapi32_init(&lcrzo_global_dll_rasapi32);
  if (ret!=LCRZO_ERR_OK)
  { /* ensure it is not loaded */
    lcrzo_global_dll_rasapi32.isloaded=LCRZO_FALSE;
  }

  /* init iphlpapi */
  ret=lcrzo_priv_dll_iphlpapi_init(&lcrzo_global_dll_iphlpapi);
  if (ret!=LCRZO_ERR_OK)
  { /* ensure it is not loaded */
    lcrzo_global_dll_iphlpapi.isloaded=LCRZO_FALSE;
  }

  /* init snmp */
  ret=lcrzo_priv_dll_snmp_init(&lcrzo_global_dll_snmp);
  if (ret!=LCRZO_ERR_OK)
  { /* ensure it is not loaded */
    lcrzo_global_dll_snmp.isloaded=LCRZO_FALSE;
  }

  return(LCRZO_ERR_OK);
}
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif

