/* This file is part of Lcrzo.
*/

#if defined LCRZODEF_SYSTEM_Unix
 /* do no need these functions */
#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
lcrzo_priv_dll_iphlpapi lcrzo_global_dll_iphlpapi;

/*-------------------------------------------------------------*/
int lcrzo_priv_dll_iphlpapi_init(lcrzo_priv_dll_iphlpapi *pdll_iphlpapi)
{ 
  pdll_iphlpapi->isloaded=LCRZO_FALSE;

  /* load the DLL */
  pdll_iphlpapi->hinstance=LoadLibrary("iphlpapi.dll");
  if ( pdll_iphlpapi->hinstance==NULL )
  { return(LCRZO_ERR_FULOADLIBRARY);
  }

  /* init functions */
  pdll_iphlpapi->GetIpAddrTable=(pGetIpAddrTable)GetProcAddress(pdll_iphlpapi->hinstance, "GetIpAddrTable");
  if ( pdll_iphlpapi->GetIpAddrTable==NULL )
  { FreeLibrary(pdll_iphlpapi->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }

  pdll_iphlpapi->GetIpNetTable=(pGetIpNetTable)GetProcAddress(pdll_iphlpapi->hinstance, "GetIpNetTable");
  if ( pdll_iphlpapi->GetIpNetTable==NULL )
  { FreeLibrary(pdll_iphlpapi->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }

  pdll_iphlpapi->GetIpForwardTable=(pGetIpForwardTable)GetProcAddress(pdll_iphlpapi->hinstance, "GetIpForwardTable");
  if ( pdll_iphlpapi->GetIpForwardTable==NULL )
  { FreeLibrary(pdll_iphlpapi->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }

  pdll_iphlpapi->GetIfEntry=(pGetIfEntry)GetProcAddress(pdll_iphlpapi->hinstance, "GetIfEntry");
  if ( pdll_iphlpapi->GetIfEntry==NULL )
  { FreeLibrary(pdll_iphlpapi->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }

  pdll_iphlpapi->SendARP=(pSendARP)GetProcAddress(pdll_iphlpapi->hinstance, "SendARP");
  if ( pdll_iphlpapi->SendARP==NULL )
  { FreeLibrary(pdll_iphlpapi->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }
  
  pdll_iphlpapi->GetIfTable=(pGetIfTable)GetProcAddress(pdll_iphlpapi->hinstance, "GetIfTable");
  if ( pdll_iphlpapi->GetIfTable==NULL )
  { FreeLibrary(pdll_iphlpapi->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }

  pdll_iphlpapi->isloaded=LCRZO_TRUE;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_dll_iphlpapi_close(lcrzo_priv_dll_iphlpapi *pdll_iphlpapi)
{ int ret;

  if (!pdll_iphlpapi->isloaded) return(LCRZO_ERR_OK);

  /* unload the DLL */
  ret=FreeLibrary(pdll_iphlpapi->hinstance);
  if (!ret) return(LCRZO_ERR_FUFREELIBRARY);

  lcrzo_er(lcrzo_priv_err_purge_int());
  return(LCRZO_ERR_OK);
}


#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
