/* This file is part of Lcrzo.
*/

#if defined LCRZODEF_SYSTEM_Unix
 /* do no need these functions */
#elif defined LCRZODEF_SYSTEM_Windows

/*-------------------------------------------------------------*/
lcrzo_priv_dll_rasapi32 lcrzo_global_dll_rasapi32;

/*-------------------------------------------------------------*/
int lcrzo_priv_dll_rasapi32_init(lcrzo_priv_dll_rasapi32 *pdll_rasapi32)
{ 
  pdll_rasapi32->isloaded=LCRZO_FALSE;

  /* load the DLL */
  pdll_rasapi32->hinstance=LoadLibrary("rasapi32.dll");
  if ( pdll_rasapi32->hinstance==NULL )
  { return(LCRZO_ERR_FULOADLIBRARY);
  }
    
  /* init functions */
  pdll_rasapi32->RasEnumConnections=(pRasEnumConnections)GetProcAddress(pdll_rasapi32->hinstance, 
#ifdef UNICODE
    "RasEnumConnectionsW"
#else
    "RasEnumConnectionsA"
#endif
    );
  if ( pdll_rasapi32->RasEnumConnections==NULL )
  { FreeLibrary(pdll_rasapi32->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }
  pdll_rasapi32->RasGetProjectionInfo=(pRasGetProjectionInfo)GetProcAddress(pdll_rasapi32->hinstance, 
#ifdef UNICODE
    "RasGetProjectionInfoW"
#else
    "RasGetProjectionInfoA"
#endif
    );
  if ( pdll_rasapi32->RasGetProjectionInfo==NULL )
  { FreeLibrary(pdll_rasapi32->hinstance);
    return(LCRZO_ERR_FUGETPROCADDRESS);
  }

  pdll_rasapi32->isloaded=LCRZO_TRUE;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_priv_dll_rasapi32_close(lcrzo_priv_dll_rasapi32 *pdll_rasapi32)
{ int ret;

  if (!pdll_rasapi32->isloaded) return(LCRZO_ERR_OK);

  /* unload the DLL */
  ret=FreeLibrary(pdll_rasapi32->hinstance);
  pdll_rasapi32->isloaded=LCRZO_FALSE;
  if (!ret) return(LCRZO_ERR_FUFREELIBRARY);

  return(LCRZO_ERR_OK);
}

#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
