/* This file is part of Lcrzo.
*/

#if defined LCRZODEF_SYSTEM_Unix
#elif defined LCRZODEF_SYSTEM_Windows
int lcrzo_priv_winpath240_check(lcrzo_conststring pathname);
int lcrzo_priv_winpath240_check(lcrzo_conststring pathname)
{ lcrzo_int32 fullpathlen;
  char buffer[_MAX_PATH];
  lcrzo_int16 language;
  lcrzo_string fullpath, fullpathclean;
  char c0, c1, c2;
  int drivenum, ret;

  /* This is a stupid Windows's limitation, and on Win9x/NT, there is no way to
     be sure this is the cause of the problem... So we have to recompute 
     the full path size */

  /* set first chars */
  c0=pathname[0];
  if (strlen(pathname)>1) c1=pathname[1]; else c1='\0';
  if (strlen(pathname)>2) c2=pathname[2]; else c2='\0';

  /* check if absolute or relative */
  if ( c0=='/' || c0=='\\' )
  { /* absolute : nothing to add */
    fullpathlen=strlen(pathname);
  }
  else if ( isalpha(c0) && c1==':' )
  { 
    if ( c2=='/' || c2=='\\' )
    { /* absolute : remove "x:" */
      fullpathlen=strlen(pathname)-2;
    }
    else
    { /* get cwd of this drive */
      if ( c0>='A' && c0<='Z' ) drivenum=1+c0-'A';
      else if ( c0>='a' && c0<='z' ) drivenum=1+c0-'a';
      else drivenum=0;
      if ( _getdcwd(drivenum, buffer, _MAX_PATH) != NULL )
      { lcrzo_er(lcrzo_string_initm_text(buffer+2, &fullpath)); /* "x:"==+2 */
      }
      else
      { lcrzo_er(lcrzo_string_initm_text("/", &fullpath));
      }
      lcrzo_er(lcrzo_string_appendm_text("/", &fullpath));
      lcrzo_er(lcrzo_string_appendm_text(pathname+2, &fullpath)); /*"x:"==+2 */
      ret=lcrzo_path_clean(fullpath, &fullpathclean);
      if (ret==LCRZO_ERR_OK)
      { fullpathlen=strlen(fullpathclean);
        lcrzo_er(lcrzo_string_free2(&fullpathclean));
      }
      else
      { fullpathlen=strlen(fullpath);
      }
      lcrzo_er(lcrzo_string_free2(&fullpath));
    }
  }
  else  
  { if ( _getcwd(buffer, _MAX_PATH) != NULL )
    { lcrzo_er(lcrzo_string_initm_text(buffer+2, &fullpath)); /* "x:"==+2 */
    }
    else
    { lcrzo_er(lcrzo_string_initm_text("/", &fullpath));
    }
    lcrzo_er(lcrzo_string_appendm_text("/", &fullpath));
    lcrzo_er(lcrzo_string_appendm_text(pathname, &fullpath));
    ret=lcrzo_path_clean(fullpath, &fullpathclean);
    if (ret==LCRZO_ERR_OK)
    { fullpathlen=strlen(fullpathclean);
      lcrzo_er(lcrzo_string_free2(&fullpathclean));
    }
    else
    { fullpathlen=strlen(fullpath);
    }
    lcrzo_er(lcrzo_string_free2(&fullpath));
  }

  /* check against the limit */
  if (fullpathlen>=240)
  { lcrzo_er(lcrzo_global_get_language(&language));
    if ( language==LCRZO_GLOBAL_LANG_FR ) 
    { lcrzo_er(lcrzo_priv_global_set_errmsglcrzo("Sous Windows, la taille totale d'un fichier ne peut pas exceder 240 caracteres"));
    }
    else
    { lcrzo_er(lcrzo_priv_global_set_errmsglcrzo("Under Windows, total path length cannot exceed 240 characters"));
    }
  }

  return(LCRZO_ERR_OK);
}

#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif

