/* This file is part of Lcrzo.
*/

int lcrzo_winhandle_init_handle(LCRZOHANDLE thehandle,
                      lcrzo_winhandle *pwinhandle)
#if defined LCRZODEF_SYSTEM_Unix
{ return(LCRZO_ERR_IEUNIMPLEMENTED);
  thehandle=thehandle;
  pwinhandle=pwinhandle;
}
#elif defined LCRZODEF_SYSTEM_Windows
{ lcrzo_int16 type;
  BOOL err;
  DWORD consolemode;
  BY_HANDLE_FILE_INFORMATION bhfi;
  DWORD readbytes, bytesavail;

  /* first, try to determine the type of the handle */
  type=LCRZO_PRIV_WAIT_SOURCE_WINHANDLE_UNKNOWN;
  err=GetConsoleMode(thehandle, &consolemode);
  if (err)
  { type=LCRZO_PRIV_WAIT_SOURCE_WINHANDLE_CONSOLE;
  }
  if (type==LCRZO_PRIV_WAIT_SOURCE_WINHANDLE_UNKNOWN)
  { err=GetFileInformationByHandle(thehandle, &bhfi);
    if (err)
    { type=LCRZO_PRIV_WAIT_SOURCE_WINHANDLE_FILE;
    }
  }
  if (type==LCRZO_PRIV_WAIT_SOURCE_WINHANDLE_UNKNOWN)
  { err=PeekNamedPipe(thehandle, NULL, 0xFFFF, &readbytes, &bytesavail, NULL);
    if (err)
    { type=LCRZO_PRIV_WAIT_SOURCE_WINHANDLE_PIPE;
    }
  }
  lcrzo_er(lcrzo_priv_err_purge_int());

  if (pwinhandle!=NULL)
  { pwinhandle->thehandle=thehandle;
    pwinhandle->openforreading=LCRZO_TRUE;
    pwinhandle->openforwriting=LCRZO_TRUE;
    pwinhandle->dataend=LCRZO_FALSE;
    pwinhandle->storeddata=NULL;
    pwinhandle->storeddatasize=0;
    pwinhandle->type=type;
  }

  return(LCRZO_ERR_OK);
}
  
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif

